<?php

namespace App\Http\Controllers;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Auth;
use Illuminate\Http\Request;
use GuzzleHttp\Client as GuzzleClient;
use GuzzleHttp\Client;
use Carbon\Carbon; 
use DateTimeZone;
use Illuminate\Support\Facades\Mail;

class OpencallController extends Controller {


    public function update(Request $request)
    {
     
      $request->validate([
            'id' => 'nullable|integer|exists:comm_store,id', // ID is optional for insert
            'to_mail' => 'required|email',
            'subject' => 'required|string',
            'cc' => 'nullable|string',
            'toggle' => 'required|in:on,off', 
        ]);
    
        // Check if the record exists
        $record = DB::table('comm_store')->where('id', $request->id)->first();
    
        if ($record) {
            // Update the record if it exists
            $affected = DB::table('comm_store')->where('id', $request->id)->update([
                'to_mail' => $request->to_mail,
                'subject' => $request->subject,
                'cc' => $request->cc ?? null, // Default to null if cc is empty
                'toggle' => $request->toggle === 'on' ? 1 : 0,
            ]);
    
            if ($affected) {
                return response()->json(['success' => true, 'message' => 'Record updated successfully.']);
            } else {
                return response()->json(['success' => false, 'message' => 'No changes were made.']);
            }
        } else {
            // Insert a new record if it does not exist
            $id = DB::table('comm_store')->insertGetId([
                'to_mail' => $request->to_mail,
                'subject' => $request->subject,
                'cc' => $request->cc ?? null,
                'toggle' => $request->toggle === 'on' ? 1 : 0,
            ]);
    
            if ($id) {
                return response()->json(['success' => true, 'message' => 'Record inserted successfully.', 'id' => $id]);
            } else {
                return response()->json(['success' => false, 'message' => 'Failed to insert record.']);
            }
        }
    
        
    }
    
    
    
    
    public function mailmodify()
    {
        
        $toggle = DB::table('comm_store')->get();
    
         $storeNames = DB::table('stores')->whereNOTnull('set_value')->get();
    
        // Pass the data to the view
        return view('mailmodify', compact('toggle', 'storeNames'));
    }
    
    public function insert(Request $request)
    {
        $storeNames = DB::table('stores')->where('dist_id',$request->distid)->get(); 
    
        try {
            DB::table('comm_store')->insert([
                'to_mail' => $request->to_mail,
                'subject' => $request->subject,
                'toggle' => $request->toggle === 'on' ? 1 : 0,
                'name' => $storeNames[0]->store_name,
                'dist_id' => $storeNames[0]->dist_id, 
            ]);
    
            return response()->json(['success' => true, 'message' => 'Record added successfully.']);
        } catch (\Exception $e) {
            return response()->json([
                'success' => false,
                'message' => 'An error occurred: ' . $e->getMessage()
            ]);
        }
    }
    public function modtimesettings() {
       
       
        return view('modtimesettings');
    }
    public function updatemod(Request $request) {
       
        DB::table('comm_moderation_autoescalation')->where('type', 'Premium')->where('type2', 'upc')->update(['elapsetime1' => $request['Elapsetime1'],'elapsetime2' =>$request['Elapsetime2'] ]);
        DB::table('comm_moderation_autoescalation')->where('type', 'Normal')->where('type2', 'upc')->update(['elapsetime1' => $request['Elapsetime3'],'elapsetime2' =>$request['Elapsetime4'] ]);


        DB::table('comm_moderation_autoescalation')->where('type', 'Enterprise')->where('type2', 'user')->update(['elapsetime1' => $request['Elapsetime5'],'elapsetime2' =>$request['Elapsetime6'] ]);
        DB::table('comm_moderation_autoescalation')->where('type', 'Priority')->where('type2', 'user')->update(['elapsetime1' => $request['Elapsetime7'],'elapsetime2' =>$request['Elapsetime8'] ]);
        DB::table('comm_moderation_autoescalation')->where('type', 'Normal')->where('type2', 'user')->update(['elapsetime1' => $request['Elapsetime9'],'elapsetime2' =>$request['Elapsetime10'] ]);

}
    
    public function sSlackCreate(Request $request) {

       
        $status = "";
        foreach(json_decode($request['id'], true) as $ids){
            $ch = DB::table('task_manager_report')->where('id', $ids)->select('Level1')->get();
            if ($ch[0]->Level1 == '1') {
                $status = "expired";  
            } else {
                $html = "";
                $html .= "Escalated List
                ";
                $html .= "Username - Type : ";
        
                $ids = json_decode($request->input('id'), true);
                $names = json_decode($request->input('name'), true);
                $types = json_decode($request->input('type'), true);
                $upcs = json_decode($request->input('upc'), true);
        
                for ($i = 0; $i < count($ids); $i++) {
                    $html .= $names[$i] . " - " . $types[$i] . " ";
                }
                $html .= "
                ";
                $html .= "UPC - UPC Type : ";
        
                for ($i = 0; $i < count($ids); $i++) {
                    $html .= $upcs[$i] . " - " . $types[$i] . " ";
                }
                $html .= "
                ";
                $html .= "Email: " . htmlspecialchars(implode(',', json_decode($request->input('email'))), ENT_QUOTES, 'UTF-8');
        
                // Output or return the generated HTML
            
        
                $client = new Client();
                $endpoint = 'https://slack.com/api/chat.postMessage';
                // $token = "xoxb-6898630061328-6861380470567-sBJdnLKIuImJcnsh2jMipbO1";
                $token = "xoxp-8114779987783-8152107895408-8131150963653-ca3668fb6af88d42a1c05fc1a998fa09";
                // $channelId = 'C07H4CK7SMB';
                $response = $client->post($endpoint, [
                    'form_params' => [
                        // 'channel' => $channelId,
                        'channel' => "C0846060XMF",
                        'token' => $token,
                        // "text" => 'Escalated List
                        // Uid: 31,32
                        // Username - User Type: TabbsArcade - Priority,BARADELLO - Normal
                        // UPC - UPC Type: 562901846732 - Normal,561109234532 - Normal
                        // Email: TabbsArcade@gmail.com,BARADELLO@gmail.com',
                        // "text" => 'Escalated List
                        // Username - Type : Hollie - Enterprise ,MKyleCraig - Free
                        // UPC - UPC Type: 50657890137 - Premium, 50212933243 - Free
                        // Email : hollie@gmail.com,mkylecraig@gmail.com',
                        "text" => $html,
                    ],
                    'headers' => [
                        'Authorization' => 'Bearer ' . $token,
                        'Content-Type' => 'application/x-www-form-urlencoded',
                    ]
                ]);
                $body = $response->getBody();
                $responseArray = json_decode($body, true);
                    foreach(json_decode($request['id'], true) as $ids){
        
                    DB::table('task_manager_report')->where('id', $ids)->update(['Level1' => '1','level1_at' => carbon::now()]);
                }
                $status = $responseArray;
            } 
        }
        return response()->json(['slack' => $status]);
    }

    public function aAsanacreate(Request $request) {

        $status = "";
        foreach($request['id'] as $ids) {
            $ch = DB::table('task_manager_report')->where('id', $ids)->select('Level2')->get();
            if ($ch[0]->Level2 != '0') {
                $status = "expired";
            } else {
                $ASANA_ACCESS_TOKEN = "2/1208713570171412/1208713794959396:67d24263201288d58d4ce079e1e589fd";
                $guzzleClient = new GuzzleClient(['base_uri' => 'https://app.asana.com/api/1.0/']);
                $headers = ['Authorization' => 'Bearer ' . $ASANA_ACCESS_TOKEN, 'Content-Type' => 'application/json',];
                if ($ASANA_ACCESS_TOKEN === false) {
                    echo "Please set the ASANA_ACCESS_TOKEN environment variable.\n";
                    exit;
                }
                $response = $guzzleClient->request('GET', 'projects', ['headers' => $headers]);
                $responseData = json_decode($response->getBody()->getContents(), true);
            
                // Print out the project IDs and names
                if (isset($responseData['data'])) {
                    foreach ($responseData['data'] as $project) {
                        if ($project['name'] === "Moderation") {
                            $projectId = $project['gid'];
                            break;
                        }
                    }
                } 
                $taskId=$projectId;
                $newProject = $guzzleClient->request('POST', 'tasks', [
                    'headers' => $headers,
                    'json' => [
                        'data' => [
                            'projects' => [$projectId], 
                            'name' => 'Moderation',
                            'assignee' => 'bryan2024nov@gmail.com',
                            'notes' => $request->input('message'),
                            // 'id' => $request->input('id'),
                            // 'subname' => $request->input('name'),
                            // 'email' => $request->input('email'),
                        ]
                    ],
                ]);
                $projectPlan = json_decode($newProject->getBody(), true)['data'];
                    
                $user = Auth::user();
        
                $message = '';
        
                if($projectPlan['gid'] && $projectPlan['gid'] != '') {
                    $message .= "Asana Subtask Created Successfully...!";
                   
                }
                foreach($request['id'] as $ids){
                    $result = DB::table('task_manager_report')->where('id',$ids)->update([
                        "Level2" => 'https://app.asana.com/0/1208876803655258/'.$projectPlan['gid'],
                        "level2_at" => carbon::now()
                    ]);
                }
                $status = $projectPlan;  
            }
        }
        return response()->json(['asana' => $status]);
    }
    public function sensormatch(Request $request) {
        $upcid = $request->input('upc');
        $res = DB::select("select nid from audio where upc='$upcid' and isrc != '' and isrc != 'DELETED'");
        return response()->json($res[0]->nid);
    }
    public function upc(Request $request) {
        // $res = DB::select("select ku.name from discography_api_report ju JOIN users ku ON ju.uid = ku.uid where ju.upc = '". $request->input('upc') ."'");

        $res = DB::select("select artist_name as name from discography_api_report where upc = '". $request->input('upc') ."'");
        return response()->json($res);
    }
    public function upcrelease(Request $request) {
        
        //->where('uid', $getid[0]->userid)$getid = DB::select('select ku.userid from comm_store_details ju JOIN comm_content_mapping ku ON ju.tbl_content_mapping_id=ku.id where ju.upc = "'.$request->input('upclists').'"');
        $res = DB::table('discography_api_report')->where('upc', $request->input('upclists'))->select('release_status')->get(); 
        $data = "";
        if(count($res) > 0) {
            $data = $res[0]->release_status;
        }else {
            $data = "NotFound";
        }
        return response()->json($data);
    }
    public function Getnotify(Request $request) {
        function getCurrentDateTimeByCountry($country, $timeZones)
        {
            if (!array_key_exists($country, $timeZones)) {
                return "Invalid country.";
            }

            // Set the time zone
            $timeZone = $timeZones[$country];

            // Get the current datetime in the specified time zone
            $dateTime = Carbon::now(new DateTimeZone($timeZone));

            // Format the datetime
            return $dateTime->format('Y-m-d H:i:s');
        }

        // Example usage
        $countryTimeZones = [
            'USA' => 'America/New_York',
            'India' => 'Asia/Kolkata',
            'UK' => 'Europe/London',
            'Australia' => 'Australia/Sydney',
            'Canada' => 'America/Toronto',
            'Japan' => 'Asia/Tokyo',
            'Germany' => 'Europe/Berlin',
            'France' => 'Europe/Paris',
            'China' => 'Asia/Shanghai',
            'Brazil' => 'America/Sao_Paulo',
            'South Africa' => 'Africa/Johannesburg',
            'Russia' => 'Europe/Moscow',
            'Mexico' => 'America/Mexico_City',
        ];

        $country = 'UK'; // Example country
        $datetime = getCurrentDateTimeByCountry($country, $countryTimeZones);
        if ($request->input('ref') == "prime") {
            $name = str_replace("@", "", $request->input('revuser'));
            $check = DB::table('comm_staffs')->where('name', $name)->select('uid')->get();
            DB::table("comm_notify")->insert([
                "tickid" => $request->input('tickid'), "sentuser" => $request->input('sentuser'), "revuser" => $check[0]->uid, "message" => $request->input('message'), "path" => $request->input("hash"), "datetime" => $datetime
            ]);
        } elseif ($request->input('ref') == "read") {
            $res = DB::table('comm_notify')->where('id', $request->input('ids'))->update([
                "read" => 1
            ]);
            if($res) {
                return response()->json('done');
            }
        } else {
            $check_res = DB::select('select ku.id, ku.tickid, ku.sentuser, ju.name, ju.image, ku.revuser, ku.message, ku.path, ku.datetime  from comm_notify ku JOIN comm_staffs ju ON ku.revuser = "'.$request->input('ids').'" and ku.sentuser = ju.uid where ku.read = 0');
            return response()->json($check_res);
        }
    }
    public function Getactionrequired(Request $request) {
        $result = DB::table('flag_comment as fc')
        ->join('users as u', 'u.uid', '=', 'fc.uid')
        ->select(
            'u.name',
            'u.mail',
            DB::raw('COUNT(fc.uid) AS total_users'),
            'fc.flagtype',
            'fc.Apply_status',
            DB::raw("
                CASE 
                    WHEN fc.flagtype = 'Warning' THEN 'Yellow'
                    WHEN fc.flagtype = 'FraudStrike' THEN 'Red'
                    ELSE 'Unknown' 
                END AS flag_color
            ")
        )
        ->where('u.uid', $request->input('userid'))
        ->groupBy('u.name', 'u.mail', 'fc.flagtype', 'fc.Apply_status')
        ->get();
        $res = DB::table('users')->where('uid', $request->input('userid'))->select('fraud_streaming')->get();
        return response()->json(['result' => $result, 'res' => $res]);
    }
    public function Overdue(Request $request) {
        $check = DB::table('comm_aging_report_log')
            ->where('tickid', $request->input('ids'))
            ->get();
        $status = "";
        if(count($check) > 0) {
            $status = "expired";
        }else {
            $p1 = DB::table('comm_tbl_smthub_ticket AS mail')
                ->join('comm_auto_escalation AS act', 'mail.action_id', '=', 'act.action')
                ->join('comm_staffs AS mem', 'mail.assigned_to', '=', 'mem.uid')
                ->join('comm_action AS at', 'mail.action_id', '=', 'at.id')
                ->where('mail.id', $request->input('ids'))
                ->select('act.level_one_escalation', 'mail.id', 'mail.from_addr', 'mail.subject', 'mail.body', 'mem.name', 'at.action_name')->get();

                $to = $p1[0]->level_one_escalation;
                $subject = "Auto-Escalation : " . $p1[0]->action_name;
                $hours = round($request->input('hours'));
                $days = intdiv($hours, 24); // Full days
                $remainingHours = $hours % 24; // Remaining hours
                $d = $days . " days " . $remainingHours . " hours.";

                $body = "
                <p>
                   As of ".date('F d').", the following ticket has been auto-escalated and requires immediate attention.
                   <ol>
                        <li style='list-style: none !important'><b>Ticketid# : </b>".$p1[0]->id."</li>
                        <li style='list-style: none !important'><b>Email-id : </b>".$p1[0]->from_addr."</li>
                        <li style='list-style: none !important'><b>Subject : </b> ".$p1[0]->subject."</li>
                        <li style='list-style: none !important'><b>Description : </b> ".$p1[0]->body."</li>
                        <li style='list-style: none !important'><b>Assign : </b> ".$p1[0]->name."</li>
                        <li style='list-style: none !important'><b>Elapsed Time : </b> ".round($request->input('hour'))." Hrs / ".$d."</li>
                   </ol> 
                </p>
                ";
            DB::table('comm_aging_report_log')->insertGetId([
                'tickid' => $request->input('ids'),
                'read' => 1,
            ]);
            Mail::send([], [], function ($message) use ($to, $body, $subject) {
                $message->from('noreply@smarthub.com', 'noreply@smarthub.com');
                $message->to($to);
                $message->subject($subject);
                $message->setBody($body, 'text/html');
                $message->replyTo($to);
            });
            $status = "sent";
        }
        return response()->json($status);
    }
    public function MultipleAssign(Request $request) {
        $resultArray = explode(',', $request->input('select_id'));
        $res = "";

        if ($request->input('username') == "Removetickets"){
            foreach ($resultArray as $item) {
                $res = DB::update('UPDATE comm_tbl_smthub_ticket SET duplicate = 0 WHERE id = ?', [$item]);
            }
        }
        else{
            foreach($resultArray as $item) {
                // dd($item);
                $res = DB::select('update comm_tbl_smthub_ticket set assigned_to = ? where id = ?', [$request->input('username'), $item]);
            }
        }

        return response()->json('done');
    }
    public function TimeProcess(Request $request) {
       
    }
    public function Showage(Request $request) {
        $query = DB::table('comm_tbl_smthub_ticket as ju')
                ->join('comm_action as ku', 'ju.action_id', '=', 'ku.id')
                ->join('comm_staffs as tu', 'ju.assigned_to', '=', 'tu.uid')
                ->join('comm_auto_escalation as au', 'ju.action_id', '=', 'au.action')
                ->select(
                    'ju.id',
                    'ju.uname',
                    'ku.action_name',
                    'ju.tickets_received',
                    'tu.name',
                    'ju.status',
                    'tu.uid',
                    'au.elapetime',
                    'au.level_one_escalation'
                )
                ->where('ju.status', '!=', 'Completed')
                ->where('ju.action_id', '!=', '')
                ->where('ju.assigned_to', '!=', '')
                ->get();
        return response()->json($query);
    }
}
