import sys
from google.oauth2 import service_account
import vertexai
from vertexai.generative_models import GenerativeModel, Part, SafetySetting, FinishReason

def generate_sql(question):
    creds = service_account.Credentials.from_service_account_file("/var/www/html/smart-hub/public/futurefous-b541452ac5cf.json")
    vertexai.init(project="futurefous", location="europe-west1", credentials=creds)
    model = vertexai.generative_models.GenerativeModel("gemini-1.5-flash-002")
    generation_config = {
        "max_output_tokens": 8192,
        "temperature": 0,
        "top_p": 0.95,
    }

    safety_settings = [
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HATE_SPEECH,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_DANGEROUS_CONTENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_SEXUALLY_EXPLICIT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HARASSMENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    ]
    return model.generate_content(question,generation_config=generation_config,safety_settings=safety_settings).text.strip()



if __name__ == "__main__":
    if len(sys.argv) > 3:

        text1 = sys.argv[1]
        result1 = text1.replace('\\"', '')

        text = sys.argv[2]
        result2 = text.replace('\\"', '')

        text = sys.argv[3]
        result3 = text.replace('\\"', '')



        base_prompt = f"""
Ticket Context:

{result1}: Details of a specific ticket.  
{result2}: Details of other tickets.
{result3}: Details of staff members it has uid which matches with assigned_to.

For {result1}, analyze the  ticket and suggest an appropriate staff member:

 -- staff member get from assigned_to column 
 -- Reference for id Admin1 - 72568 Admin2 - 72569 


output:
<suitable staff member name>

Provide a response in **seconds**. Do **not** modify or query the database.

{result1}  
{result2}


  """
       # print(generate_sql(prompt))  

        # Combine base prompt with the condition
        # final_prompt = f"{base_prompt}\n{condition}\nPlease give select query for below questions - only query without explanation\n{question}"
        
        print(generate_sql(base_prompt))


          







