import sys
from google.oauth2 import service_account
import vertexai
from vertexai.generative_models import GenerativeModel, Part, SafetySetting, FinishReason

def generate_sql(question):
    creds = service_account.Credentials.from_service_account_file("/var/www/html/smart-hub/public/futurefous-b541452ac5cf.json")
    vertexai.init(project="futurefous", location="europe-west1", credentials=creds)
    model = vertexai.generative_models.GenerativeModel("gemini-1.5-flash-002")
    generation_config = {
        "max_output_tokens": 8192,
        "temperature": 0,
        "top_p": 0.95,
    }

    safety_settings = [
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HATE_SPEECH,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_DANGEROUS_CONTENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_SEXUALLY_EXPLICIT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HARASSMENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    ]
    return model.generate_content(question,generation_config=generation_config,safety_settings=safety_settings).text.strip()



if __name__ == "__main__":
    if len(sys.argv) > 1:

        text1 = sys.argv[1]
        body = text1.replace('\\"', '')

       
        base_prompt = f"""

{body}: email body content

For {body}, analyze the body content and tell me if they mention something like "let us know" or if they say "contact us" or similar phrases suggesting that the user needs to reach out or take action before proceeding. 

- Detect if the email asks to "let us know," "contact us," or similar.
- If the body suggests any such action, return **yes**.
- If not, return **no**.

output:
<yes/no>

Provide a response in **seconds**. Do **not** modify or query the database.

{body}  

"""


#         base_prompt = f"""

# {body}: email body content


# For {body}, analyze the body content and tell me if there is a urgency or they said before proceed contact us like that 
 
#  Detect Urgency: Look for phrases indicating that action should be taken quickly, like "urgent," "as soon as possible," "immediate attention," etc.
# Detect "Contact Us" or Similar: Look for statements or implied instructions like "please reach out," "contact us," "let us know," etc.
# So, based on your input:

# If an email body contains any phrases that imply urgency or suggests reaching out or contacting someone, the output would be yes. If not, the output would be no.

#  -

# output:
# <yes/no>

# Provide a response in **seconds**. Do **not** modify or query the database.

# {body}  



#   """
       # print(generate_sql(prompt))  

        # Combine base prompt with the condition
        # final_prompt = f"{base_prompt}\n{condition}\nPlease give select query for below questions - only query without explanation\n{question}"
        
        print(generate_sql(base_prompt))


          







