import sys
from google.oauth2 import service_account
import vertexai
from vertexai.generative_models import GenerativeModel, Part, SafetySetting, FinishReason

def generate_sql(question):
    creds = service_account.Credentials.from_service_account_file("/var/www/html/smart-hub/public/futurefous-b541452ac5cf.json")
    vertexai.init(project="futurefous", location="europe-west1", credentials=creds)
    model = vertexai.generative_models.GenerativeModel("gemini-1.5-flash-002")
    generation_config = {
        "max_output_tokens": 8192,
        "temperature": 0,
        "top_p": 0.95,
    }

    safety_settings = [
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HATE_SPEECH,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_DANGEROUS_CONTENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_SEXUALLY_EXPLICIT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HARASSMENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    ]
    return model.generate_content(question,generation_config=generation_config,safety_settings=safety_settings).text.strip()



if __name__ == "__main__":
    if len(sys.argv) > 1:

        text1 = sys.argv[1]
        result = text1.replace('\\"', '')

#         base_prompt = f"""
# {result}: all ticket details

# Task:
# - Analyze the ticket details, focusing on the 'body', 'body content', 'subject', and 'subject content' fields.
# - Identify any duplicate entries from the same user based on matching content.
# - For any group of duplicates (3 or more), return **one less than the total count**. For example, if there are 10 duplicates, return 9. If there are 5 duplicates, return 4.
# - Return the **ticket IDs** for duplicates only, with each set of duplicates represented once. 
# - Do not modify or query the database.

# Ensure that only exact duplicates in content are detected and listed.

# {result}
# """
        base_prompt = f"""
{result}: all ticket details

Task:
- Analyze the ticket details, focusing on the 'body', 'body content', 'subject', and 'subject content' fields.
- Identify any exact duplicate entries from the same user based on matching content.
- For any group of duplicates (3 or more), return **one less than the total count**, but **omit the first duplicate**. For example, if there are 10 duplicates, return 9 duplicates starting from the second one. If there are 5 duplicates, return 4 duplicates starting from the second one.
- Return the **ticket IDs** for duplicates only, omitting the first ticket ID in each group of duplicates (3 or more).
- Do not modify or query the database.

output format:
original ticket id: <original_ticket_id> duplicate ticket ids: <list_of_duplicate_ids>

Ensure that only exact duplicates in content are detected and listed.

{result}
"""


#         base_prompt = f"""
# {result}: all ticket details

# Task:
# - Analyze the ticket details, focusing on the 'body', 'body content', 'subject', and 'subject content' fields.
# - Identify any exact duplicate entries from the same user based on matching content.
# - For any group of duplicates (3 or more), return **one less than the total count**, but **omit the first duplicate**. For example, if there are 10 duplicates, return 9 duplicates starting from the second one. If there are 5 duplicates, return 4 duplicates starting from the second one.
# - Return the **ticket IDs** for duplicates only, omitting the first ticket ID in each group of duplicates (3 or more).
# - Do not modify or query the database.
# output:
# [ticekt ids]
# example: [1,2,3,....]

# Ensure that only exact duplicates in content are detected and listed.



# {result}
# """


       # print(generate_sql(prompt))  

        # Combine base prompt with the condition
        # final_prompt = f"{base_prompt}\n{condition}\nPlease give select query for below questions - only query without explanation\n{question}"
        
        print(generate_sql(base_prompt))


          







