import sys
from google.oauth2 import service_account
import vertexai
from vertexai.generative_models import GenerativeModel, Part, SafetySetting, FinishReason

def generate_lang(question):
    creds = service_account.Credentials.from_service_account_file("/var/www/html/smart-hub/public/futurefous-b541452ac5cf.json")
    vertexai.init(project="futurefous", location="europe-west1", credentials=creds)
    model = vertexai.generative_models.GenerativeModel("gemini-1.5-flash-002")
    generation_config = {
        "max_output_tokens": 8192,
        "temperature": 0,
        "top_p": 0.95,
    }

    safety_settings = [
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HATE_SPEECH,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_DANGEROUS_CONTENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_SEXUALLY_EXPLICIT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HARASSMENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    ]
    return model.generate_content(question,generation_config=generation_config,safety_settings=safety_settings).text.strip()



if __name__ == "__main__":
    if len(sys.argv) > 2:

        text1 = sys.argv[1]
        #result1 = text1.replace('\\"', '')

        text2 = sys.argv[2]
        with open(text1, 'r', encoding='utf-8') as file:
            text = file.read()

        # Print the contents of the file (for debugging)
       # print(f"File content: {text}")

# Now you can process 'text' (the content of the file) as needed, e.g., language detection

       #     print(f"Received text: {text1}")  # Print the received text to debug

# Continue with your existing logic (e.g., language detection, etc.)

        base_prompt = f"""
Detect the language of the following text and translate it into {text2}.

IMPORTANT:
1. If the text contains the phrase "Many Warm Regards," or "The RouteNote Team," do not translate these words. Return them exactly as they are.
2. For any instance of "Dear <name>," consider "<name>" as a proper name and leave it unchanged.
3.no need to remove html tags and style in that only translate the text 

Output format:
converted language: <translated text>

no need any further explanation , just return the converted text

Text:
{text}
"""

#         base_prompt = f"""
# Detect the language of this text and convert into chinese

# in text : after Dear consider the word as name (Dear <name>,)so consider this as name no need to change name return as it is 

# IMPORTANT:
# **if text contains  below words
# Many Warm Regards,
# The RouteNote Team
# no need to these change words , return as it is **

# output should be
# converted language:<converted text>



# no need any further explanation , just return the converted text
# {text}
#   """
        print(generate_lang(base_prompt))  

        # Combine base prompt with the condition
        # final_prompt = f"{base_prompt}\n{condition}\nPlease give select query for below questions - only query without explanation\n{question}"
        
       # print(text1)

        
          







