import sys
from google.oauth2 import service_account
import vertexai
from vertexai.generative_models import GenerativeModel, Part, SafetySetting, FinishReason

def generate_sql(question):
    creds = service_account.Credentials.from_service_account_file("/var/www/html/smart-hub/public/futurefous-b541452ac5cf.json")
    vertexai.init(project="futurefous", location="europe-west1", credentials=creds)
    model = vertexai.generative_models.GenerativeModel("gemini-1.5-flash-002")
    generation_config = {
        "max_output_tokens": 8192,
        "temperature": 0,
        "top_p": 0.95,
    }

    safety_settings = [
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HATE_SPEECH,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_DANGEROUS_CONTENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_SEXUALLY_EXPLICIT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HARASSMENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    ]
    return model.generate_content(question,generation_config=generation_config,safety_settings=safety_settings).text.strip()



if __name__ == "__main__":
    if len(sys.argv) > 2:

        text1 = sys.argv[1]
        subject = text1.replace('\\"', '')

        text = sys.argv[2]
        results = text.replace('\\"', '')

        text = sys.argv[2]
        body = text.replace('\\"', '')


        base_prompt = f"""
Ticket Context:

{subject}: subject of particular ticket. {body}: body content of particular ticket.   
{results}: Details of other tickets.

For {subject}  {body}, analyze the tone of the ticket :

1. **Subject & Body Analysis**: Review the content and tone of the ticket (subject and body). Provide a recommendation based on the nature of the request.

2. **Tone**:  
   - If the tone appears **urgent** or **high-priority**, suggest an **Admin** (Admin1 or Admin2) based on their current workload and the ticket's urgency.  
   - If the tone seems **neutral**, **friendly**, or **less pressing**, suggest a **Staff** member instead.

### Additional Notes:
- If the assigned staff member for this ticket has **more than 2 uncompleted tickets**, include a note to inform the user about the staff member's current workload.
- Always check {results} for trends or staff expertise related to the ticket.
- **Suggest only one staff member** for handling the ticket.

**Output Example**: 
- Tone: [description of tone, e.g., Neutral, Urgent, Friendly, Frustrated]
- Suggestion: Suitable Staff Member: [Staff Name]  
  - Experience: [Staff Name] has handled similar tickets in the past.  for this refer {results} in that assigned_to is there by using that 72568 is Admin1 and 72569 is Admin2
  - Workload: check that suitable staff member worload is managable or not.check {results} in that completed_at is not empty then it is considered as completed.

**Important**:
- **No need to show admin ID**. Simply mention **Admin1** or **Admin2** without referencing any IDs.

**Example of Staff Assignment**:
- If **no staff is assigned**: Suggest a staff member such as Admin1 or Admin2.
- If a staff member is **already assigned** (e.g., Admin1 or Admin2), inform them that they can seek assistance from another staff member with relevant expertise if needed. Use the format **Admin1** or **Admin2** without showing any IDs.

Only suggest **Admins** (Admin1 or Admin2) — do not suggest Superadmin.


Provide a response in **seconds**. Do **not** modify or query the database.

{subject} {body}  
{results}
"""

       # print(generate_sql(prompt))  

        # Combine base prompt with the condition
        # final_prompt = f"{base_prompt}\n{condition}\nPlease give select query for below questions - only query without explanation\n{question}"
        
        print(generate_sql(base_prompt))


          







