import sys
from google.oauth2 import service_account
import vertexai
from vertexai.generative_models import GenerativeModel, Part, SafetySetting, FinishReason

def generate_sql(question):
    creds = service_account.Credentials.from_service_account_file("/var/www/html/smart-hub/public/futurefous-b541452ac5cf.json")
    vertexai.init(project="futurefous", location="europe-west1", credentials=creds)
    model = vertexai.generative_models.GenerativeModel("gemini-1.5-flash-002")
    generation_config = {
        "max_output_tokens": 8192,
        "temperature": 0,
        "top_p": 0.95,
    }

    safety_settings = [
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HATE_SPEECH,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_DANGEROUS_CONTENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_SEXUALLY_EXPLICIT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HARASSMENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    ]
    return model.generate_content(question,generation_config=generation_config,safety_settings=safety_settings).text.strip()



if __name__ == "__main__":
    if len(sys.argv) > 1:

        text1 = sys.argv[1]
        value = text1.replace('\\"', '')


        base_prompt = f"""
        by using the{value}, convert it into html and return it

        sample html refer below but the values are need to be changed based on the {value}
       <!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
</head>
<body>

   <div style="display: grid;gap: 8px;line-height: 24px;">

   

    <div class="section">
        <h3>Sentiment Analysis:</h3>
        <p><strong>Tone:</strong> Frustrated. The user is clearly dissatisfied with the situation and demands account closure without any further delays.</p>
    </div>

    <div class="section">
        <span style="display: flex;"><p style="font-weight: 800;font-size: medium;">AI Suggested Staff Member:</p>&nbsp; <p>Admin1</p></span> 
       

        <p><strong>Experience:</strong> Admin1 has successfully handled multiple account closure requests, having completed <strong>4 account closure tickets</strong> in the past. Admin1 is well-equipped to manage this ticket efficiently.</p>

        <p><strong>Workload:</strong></p>
    <ul> <li>Admin1 currently has 2 uncompleted tickets.</li>
        <li> Admin2 currently has 3 uncompleted tickets.</li>
        <li>Given these workloads, Admin1 is the more suitable choice to handle this request promptly.</li></ul>
    </div>

    <div class="section">
        <h3>The rnuser_new previous ticket history:</h3>
        <ul>
            <li>Ticket #126: 
               <ul><li><strong>Tone:</strong> Neutral. </li>
                <li> Ticket completed by Admin1.</li></ul> </li>
            <li>Ticket #114:<ul><li><strong>Tone:</strong> Normal.</li>
                <li> Ticket completed by Admin2.</li></ul> </li>
            <li>Ticket #110:<ul><li> <strong>Tone:</strong> Neutral. </li>
            <li>Ticket completed by Admin1.</li></ul> </li>
        </ul>
    </div>
</div>
</body>
</html>


{value}
"""

       # print(generate_sql(prompt))  

        # Combine base prompt with the condition
        # final_prompt = f"{base_prompt}\n{condition}\nPlease give select query for below questions - only query without explanation\n{question}"
        
        print(generate_sql(base_prompt))


          







