import sys
from google.oauth2 import service_account
import vertexai
from vertexai.generative_models import GenerativeModel, Part, SafetySetting, FinishReason

def generate_sql(question):
    creds = service_account.Credentials.from_service_account_file("/var/www/html/smart-hub/public/futurefous-b541452ac5cf.json")
    vertexai.init(project="futurefous", location="europe-west1", credentials=creds)
    model = vertexai.generative_models.GenerativeModel("gemini-1.5-flash-002")
    generation_config = {
        "max_output_tokens": 8192,
        "temperature": 0,
        "top_p": 0.95,
    }

    safety_settings = [
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HATE_SPEECH,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_DANGEROUS_CONTENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_SEXUALLY_EXPLICIT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HARASSMENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    ]
    return model.generate_content(question,generation_config=generation_config,safety_settings=safety_settings).text.strip()



if __name__ == "__main__":
    if len(sys.argv) > 3:

        text1 = sys.argv[1]
        typeofuser = text1.replace('\\"', '')

        text = sys.argv[2]
        question = text.replace('\\"', '')

        pages = sys.argv[3]
        page = pages.replace('\\"', '')
        page_parts = page.split(".")
    
        page = page_parts[0]   
        tagid = page_parts[1]

        base_prompt = f"""

             ONLY generate SQL queries for valid and coherent questions. If the input is nonsensical or gibberish, output: `INVALID REQUEST`.
    - For greetings or general words(e.g., hello, hi, good morning, thank you): `INVALID REQUEST`.
    - For thanks-related questions (e.g., thanks, thank you, appreciate,sorry): `INVALID REQUEST`.
    - For requests related to help (e.g., what can you do for me, how can you help me): `INVALID REQUEST`.
    - For requests related to your name (e.g., what is your name, tell me your name): `INVALID REQUEST`.

use "name" as the prompt for any username-related requests.


DO NOT generate queries for the following:
- `UPDATE`, `DELETE`, `ALTER`, `ADD`, `CREATE`, or any database credentials (e.g., passwords, activation keys). Output: `INVALID REQUEST`.
- Requests column names, or database structure details. Output: `INVALID REQUEST`.
DO NOT generate nonsensical or gibberish,output: `INVALID REQUEST`.

**General Guidelines:**
- Only generate `SELECT` queries.
- Adhere to MySQL 5.6.51 syntax. Avoid modern constructs (e.g., `HAVING`).
- Only generate queries, no extra text or explanation.
- Identify input numbers: 
  - **13-digit** numbers = UPC.
  - Any other number = user ID (UID) or Ticket id .
- Include provided values in the query.

comm_tbl_smthub_ticket.status column have values stage by stage
    .Received 
    .Waiting For User Action
    .Admin Action Needed
    .Completed

--All group by elements must in select clause
--if group by used, all select elements must in group by
comm_tbl_smthub_ticket.priority column having values Easy,Moderate,High and Very High

comm_staffs name are Superadmin,Admin1,Admin2 and type has Admin and Staff.
 

Tickets have priority column having values Easy,Moderate,High and Very High

Availabe action names and its id are
1 	Account Closure 
2 	Content Mapping 	
3 	Youtube OAC 
4 	Revenue Share
5 	Disapprove all pending releases 
6 	Delete all unfinished releases 
7 	Adds a note to all RFS releases 
8 	Adds a flag to the account 
9 	RFS all active releases 
10 	Takedown for all stores 
11 	Unlinks all YT channels 
12 	Manual Account Activation 
14 	Close Thread

Availabe tag_name and its id are 
1 Account Closures 
2 	Content Mapping 
3 	YouTube 	
4 	Revenue Share 	
6 	403 Error 
7 	Allow List 
8 	Artwork 		
9 	Audio Issue 		
10 	Bank Transfer 		
12 	Copyright Infringement 		
13 	Facebook/Instagram Verification 		
14 	Facebook/Instagram/CID 		
15 	Failed Upload/ Failed Takedown 		
16 	Mod Delay 		
17 	New Feature Feedback 		
18 	Password 		
19 	Payments & Pay Updates 		
20 	Refund 		
21 	RN Advance 		
22 	Stats & Reports 				
32 	PayPal

match the columns what i mention in each select query don't get anything .

comm_staffs have column name not username.
users have column name not username.

For direct questions related to individual tables:
You can query the relevant table directly using the following individual queries:


Always consider comm_tbl_smthub_ticket.id 
smart_schedule column has datetime.when ticket was scheduled for that we use it.
tickets created date time -- check column tickets_received.
instant action has 0 or 1 

overdue tickets check due_date and completed_at not null.

current month tickets :
  example -- MONTH(tickets_received) = MONTH(CURDATE()) AND YEAR(tickets_received) = YEAR(CURDATE()) 


if they ask about category refers the action_name. if action_name empty then check tag_name.

SELECT id, keys1, uid, uname, upc_id, subject, from_name, from_addr, to_name, to_addr, body, action_id, notes, request_information, tickets_received, assigned_to, due_date, instant_action, smart_schedule, priority, tag_id, completed_at, status, internal_thread, commentry_assign, commentry_user, conf_email, last_cron_update FROM comm_tbl_smthub_ticket;

use this comm_staffs for comm_tbl_smthub_ticket.assigned_to == comm_staffs.uid
SELECT uid, name, mail, email_verified_at, password, remember_token, created_at, updated_at, image, read_count, mail_signature, auto_suggest, type FROM comm_staffs;

**must add where condition assigned_to = {typeofuser} **
**must add this condition WHERE  (action_id NOT IN (1, 2, 3, 4) OR action_id IS NULL) in all generated query**
**must select all elements from table**
**given query must be in version 5.6.51**
**make sure that group by elements must in select clause and select clause elements must be in group by.**
**consider that seller as name**
  """
       # print(generate_sql(prompt))  

        if page == 'upc':
            condition = "**must add this condition WHERE upc is not null and upc != '' and additionally checks that tag_id is null in all generated query**"
        elif page == 'user':
            condition = "**must add this condition WHERE upc is null and additionally checks that tag_id is null in all generated query**"
        elif page == 'tag':
            condition = f"**must add this condition WHERE tag_id = {tagid} in all generated query**"
        elif page == 'all':
            condition = "additionally checks that tag_id is null and tag_id == '' "

        # Combine base prompt with the condition
        final_prompt = f"{base_prompt}\n{condition}\nPlease give select query for below questions - only query without explanation\n{question}"
        
        print(generate_sql(final_prompt))


    else: 

        text = sys.argv[1]
        question = text.replace('\\"', '')
        
        pages = sys.argv[2]
        page = pages.replace('\\"', '')
        page_parts = page.split(".")
    
        page = page_parts[0]   
        tagid = page_parts[1]

        base_prompt = """

             ONLY generate SQL queries for valid and coherent questions. If the input is nonsensical or gibberish, output: `INVALID REQUEST`.
    - For greetings or general words(e.g., hello, hi, good morning, thank you): `INVALID REQUEST`.
    - For thanks-related questions (e.g., thanks, thank you, appreciate,sorry): `INVALID REQUEST`.
    - For requests related to help (e.g., what can you do for me, how can you help me): `INVALID REQUEST`.
    - For requests related to your name (e.g., what is your name, tell me your name): `INVALID REQUEST`.

use "name" as the prompt for any username-related requests.


DO NOT generate queries for the following:
- `UPDATE`, `DELETE`, `ALTER`, `ADD`, `CREATE`, or any database credentials (e.g., passwords, activation keys). Output: `INVALID REQUEST`.
- Requests column names, or database structure details. Output: `INVALID REQUEST`.
DO NOT generate nonsensical or gibberish,output: `INVALID REQUEST`.

**General Guidelines:**
- Only generate `SELECT` queries.
- Adhere to MySQL 5.6.51 syntax. Avoid modern constructs (e.g., `HAVING`).
- Only generate queries, no extra text or explanation.
- Identify input numbers: 
  - **13-digit** numbers = UPC.
  - Any other number = user ID (UID) or Ticket id .
- Include provided values in the query.

comm_tbl_smthub_ticket.status column have values stage by stage
    .Received 
    .Waiting For User Action
    .Admin Action Needed
    .Completed

--All group by elements must in select clause
--if group by used, all select elements must in group by
comm_tbl_smthub_ticket.priority column having values Easy,Moderate,High and Very High

comm_staffs name are Superadmin,Admin1,Admin2 and type has Admin and Staff.
 

Tickets have priority column having values Easy,Moderate,High and Very High

Availabe action names and its id are
1 	Account Closure 
2 	Content Mapping 	
3 	Youtube OAC 
4 	Revenue Share
5 	Disapprove all pending releases 
6 	Delete all unfinished releases 
7 	Adds a note to all RFS releases 
8 	Adds a flag to the account 
9 	RFS all active releases 
10 	Takedown for all stores 
11 	Unlinks all YT channels 
12 	Manual Account Activation 
14 	Close Thread

Availabe tag_name and its id are 
1 Account Closures 
2 	Content Mapping 
3 	YouTube 	
4 	Revenue Share 	
6 	403 Error 
7 	Allow List 
8 	Artwork 		
9 	Audio Issue 		
10 	Bank Transfer 		
12 	Copyright Infringement 		
13 	Facebook/Instagram Verification 		
14 	Facebook/Instagram/CID 		
15 	Failed Upload/ Failed Takedown 		
16 	Mod Delay 		
17 	New Feature Feedback 		
18 	Password 		
19 	Payments & Pay Updates 		
20 	Refund 		
21 	RN Advance 		
22 	Stats & Reports 				
32 	PayPal


match the columns what i mention in each select query don't get anything .

comm_staffs have column name not username.
users have column name not username.

For direct questions related to individual tables:
You can query the relevant table directly using the following individual queries:

overdue tickets check due_date and completed_at not null.

Always consider comm_tbl_smthub_ticket.id 
smart_schedule column has datetime.when ticket was scheduled for that we use it.
tickets created date time -- check column tickets_received.
instant action has 0 or 1 

current month tickets :
  example -- MONTH(tickets_received) = MONTH(CURDATE()) AND YEAR(tickets_received) = YEAR(CURDATE()) 

if they ask about category refers the action_name. if action_name empty then check tag_name.

SELECT id, keys1, uid, uname, upc_id, subject, from_name, from_addr, to_name, to_addr, body, action_id, notes, request_information, tickets_received, assigned_to, due_date, instant_action, smart_schedule, priority, tag_id, completed_at, status, internal_thread, commentry_assign, commentry_user, conf_email, last_cron_update FROM comm_tbl_smthub_ticket;

use this comm_staffs for comm_tbl_smthub_ticket.assigned_to == comm_staffs.uid
SELECT uid, name, mail, email_verified_at, password, remember_token, created_at, updated_at, image, read_count, mail_signature, auto_suggest, type FROM comm_staffs;

**must add this condition WHERE (action_id NOT IN (1, 2, 3, 4) OR action_id IS NULL) in all generated query**
**must select all elements from table**
**given query must be in version 5.6.51**
**make sure that group by elements must in select clause and select clause elements must be in group by.**
**consider that seller as name**
  """
        
        if page == 'upc':
            condition = "**must add this condition WHERE upc is not null and upc != ''  and additionally checks that tag_id is null in all generated query**"
        elif page == 'user':
            condition = "**must add this condition WHERE upc is null and additionally checks that tag_id is null in all generated query**"
        elif page == 'tag':
            condition = f"**must add this condition WHERE tag_id = {tagid} in all generated query**"
        elif page == 'all':
             condition = "additionally checks that tag_id is null and tag_id == '' "

        # Combine base prompt with the condition
        final_prompt = f"{base_prompt}\n{condition}\n  Please give select query for below questions - only query without explanation\n{question}"

        print(generate_sql(final_prompt))

           







