import sys
from google.oauth2 import service_account
import vertexai
from vertexai.generative_models import GenerativeModel, Part, SafetySetting, FinishReason





def generate_sql(question):
    creds = service_account.Credentials.from_service_account_file("/var/www/html/smart-hub/public/futurefous-b541452ac5cf.json")
    vertexai.init(project="futurefous", location="europe-west1", credentials=creds)
    model = vertexai.generative_models.GenerativeModel("gemini-1.5-flash-002")
    generation_config = {
        "max_output_tokens": 8192,
        "temperature": 0,
        "top_p": 0.95,
    }

    safety_settings = [
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HATE_SPEECH,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_DANGEROUS_CONTENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_SEXUALLY_EXPLICIT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HARASSMENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    ]
    return model.generate_content(question,generation_config=generation_config,safety_settings=safety_settings).text.strip()



if __name__ == "__main__":
    if len(sys.argv) > 2:

        text = sys.argv[1]
        question1 = text.replace('\\"', '')

        text1 = sys.argv[2]
        question2 = text1.replace('\\"', '')

        prompt =f"""
             
Merge with the first question if the second lacks sufficient information or relevance; otherwise, use the second question without explanation.


Case 1: Merge the Questions

First Question: "What tickets are overdue?"
Second Question: "Are there any unresolved tickets flagged as 'Critical'?"
Merged Prompt: "What overdue tickets are flagged as 'Critical' or unresolved?"

First Question: "Which forms were submitted in the last week?"
Second Question: "Do any of these forms have missing email confirmations?"
Merged Prompt: "Which forms submitted in the last week have missing email confirmations?"

First Question: "List all actions completed this month."
Second Question: "What tickets are awaiting review?"
Merged Prompt: "What tickets awaiting review have actions completed this month?"

Case 2: Use the Second Question As-Is

First Question: "What’s the resolution time for tickets created today?"
Second Question: "List tickets resolved this week."
Prompt: "List tickets resolved this week." (The second question is more relevant and distinct.)

First Question: "Find tickets tagged as 'High Priority'."
Second Question: "What tickets are currently unassigned?"
Prompt: "What tickets are currently unassigned?" (No overlap or relevance to merge.)

First Question: "Show account closure forms submitted last month."
Second Question: "Which forms mention other distributors?"
Prompt: "Which forms mention other distributors?" (The second question provides unique insight.)

First Question: "list top 10 users by earnings"
Second Question: "list the upc belong to the user tamil"
Prompt: "list the upc belong to the user tamil" (The second question provides unique insight.)

First Question: "list the upc belong to the user tamil"
Second Question: "list top 10 users by earnings"
Prompt: "list top 10 users by earnings" (The second question provides unique insight.)

First Question: "top 10 user based on tickets"
Second Question: "how many ticket user sellerrn requested in last week"
Prompt: "how many ticket user sellerrn requested in last week" (The second question provides unique insight.)

First Question: "how many ticket user sellerrn requested in last week""
Second Question: "top 10 user based on tickets"
Prompt: "top 10 user based on tickets" (The second question provides unique insight.)

First Question: "How many forms submitted last month and what type of forms?""
Second Question: "tell me how many tickets created in past one week"
Prompt: tell me how many tickets created in past one week" (The second question provides unique insight.)


**only display questions no need other explanation.**

**make as single question don't be multiple questions.**


if question1 and question2 related then merge and give the response.
Example:
Question1 relate to tickets and question2 asks about it's id then merge give result.

if questions 1 is about completed and questions 2 about pending or open .consider both are unrelated
if questions1 is about total users and questions 2 about any particular user.consider both are unrelated

- If questions 1 and 2 are unrelated,  always return the second statement.
- If both questions refer to the same data aspect, merge them based on their relevance.

question1:{question1} 
question2:{question2}




        """

     
        print(generate_sql(prompt))
    else:
        print("Provide input as command-line argument")








