import sys
from google.oauth2 import service_account
import vertexai
from vertexai.generative_models import GenerativeModel, Part, SafetySetting, FinishReason

def generate_sql(question):
    creds = service_account.Credentials.from_service_account_file("/var/www/html/smart-hub/public/futurefous-b541452ac5cf.json")
    vertexai.init(project="futurefous", location="europe-west1", credentials=creds)
    model = vertexai.generative_models.GenerativeModel("gemini-1.5-flash-002")
    generation_config = {
        "max_output_tokens": 8192,
        "temperature": 0,
        "top_p": 0.95,
    }

    safety_settings = [
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HATE_SPEECH,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_DANGEROUS_CONTENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_SEXUALLY_EXPLICIT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HARASSMENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    ]
    return model.generate_content(question,generation_config=generation_config,safety_settings=safety_settings).text.strip()



if __name__ == "__main__":
    if len(sys.argv) > 1:

        text1 = sys.argv[1]
        result1 = text1.replace('\\"', '')



        base_prompt = f"""
Ticket Context:

{result1}: Details of a specific ticket.  

For {result1}, analyze the tone of the ticket 

1. **Subject & Body Analysis**: Review the content and tone of the ticket (subject and body or subject_content and body_content). Provide a recommendation based on the nature of the request.

2. **Tone**:  
   - If the tone appears **urgent** or **high-priority**, 

describe tone in one word like 
Concerned
Urgent
Frustrated
Disappointed
Anxious
Impatient
Agitated
Alarmed
Exasperated
Overwhelmed
Irritated
Defeated
Pressured
Worried
Restless

output format:
<tone>

--only return tone if there is urgency, frustration, disappointment, or any of the above tones. If not, return none.

Provide a response in **seconds**. Do **not** modify or query the database.

{result1}  
"""


       # print(generate_sql(prompt))  

        # Combine base prompt with the condition
        # final_prompt = f"{base_prompt}\n{condition}\nPlease give select query for below questions - only query without explanation\n{question}"
        
        print(generate_sql(base_prompt))


          







