@extends('includes.layout')
@section('content')

<script src="https://cdn.jsdelivr.net/npm/alpinejs@3.x.x/dist/cdn.min.js" defer></script>

<div class="p-4 overflow-y-auto h-5/6">
    <nav aria-label="breadcrumb" class="w-max">
    <ol class="flex flex-wrap items-center w-full px-4 py-2 rounded-md bg-blue-gray-50 bg-opacity-60">
        <li
        class="flex items-center font-sans text-sm antialiased font-normal leading-normal transition-colors duration-300 cursor-pointer text-blue-gray-900 hover:text-light-blue-500">
        <a href="/settings" class="opacity-60">
            <svg xmlns="http://www.w3.org/2000/svg" class="w-4 h-4" viewBox="0 0 20 20"
            fill="currentColor">
            <path
                d="M10.707 2.293a1 1 0 00-1.414 0l-7 7a1 1 0 001.414 1.414L4 10.414V17a1 1 0 001 1h2a1 1 0 001-1v-2a1 1 0 011-1h2a1 1 0 011 1v2a1 1 0 001 1h2a1 1 0 001-1v-6.586l.293.293a1 1 0 001.414-1.414l-7-7z">
            </path>
            </svg>
        </a>
        <span
            class="mx-2 font-sans text-sm antialiased font-normal leading-normal pointer-events-none select-none text-blue-gray-500">
            /
        </span>
        </li>
        <li
        class="flex items-center font-sans text-sm antialiased font-normal leading-normal transition-colors duration-300 cursor-pointer text-blue-gray-900 hover:text-light-blue-500">
        <a href="/groups" class="opacity-60">
            <span>
                departments
            </span>
        </a>
        </li>
    </ol>
    </nav>
    <h1 class="text-2xl font-sans font-bold">Department Management</h1>
    <br>
    
    @php
        $result = DB::table('comm_groupmanagement')->get();
        $result1 =  DB::table('comm_associate_user as cu')->join('comm_groupmanagement as hu', 'cu.g_name', '=', 'hu.id')->select('cu.id', 'cu.user_name', 'hu.groupname')->get();


        $result = DB::table('comm_roles')->where('show_hide','1')->get();
        $result1 =  DB::table('comm_associate_user as cu')->join('comm_roles as hu', 'cu.g_name', '=', 'hu.id')->select('cu.id', 'cu.user_name', 'hu.roles_name')->get();


        
        
    @endphp 
    <div class="flex w-full gap-10">

<!-- -------------------------- Add/ Modify Group --------------------------- -->

    <div class="relative flex flex-col mt-6 text-gray-700 bg-white shadow-md bg-clip-border rounded-xl w-1/2 overflow-y-auto">
    <div class="p-6 w-full " style="height: 26.5rem;">
        <div>
            <h5 class="block mb-2 font-sans text-xl antialiased font-semibold leading-snug tracking-normal text-blue-gray-900">
            Add/ Modify Department&nbsp; <span style="color: red;">*</span>
            </h5>
            <p class="block font-sans text-base antialiased font-light leading-relaxed text-inherit">
                <div class="w-auto flex items-center gap-4">
                    <div class="relative h-10 w-full min-w-[200px] ">
                        <input type="text" placeholder="Group Name" id="GroupName" value="{{ $Groupname_up ?? '' }}"
                        class="peer h-full w-full rounded-[7px]  !border  !border-gray-300 border-t-transparent bg-transparent bg-white px-3 py-2.5 font-sans text-sm font-normal text-blue-gray-700  shadow-lg shadow-gray-900/5 outline outline-0 ring-4 ring-transparent transition-all placeholder:text-gray-500 placeholder-shown:border placeholder-shown:border-blue-gray-200 placeholder-shown:border-t-blue-gray-200 focus:border-2  focus:!border-gray-900 focus:border-t-transparent focus:!border-t-gray-900 focus:outline-0 focus:ring-gray-900/10 disabled:border-0 disabled:bg-blue-gray-50" />
                    </div>
                    <button
                class="align-middle select-none font-sans font-bold text-center uppercase transition-all disabled:opacity-50 disabled:shadow-none disabled:pointer-events-none text-xs py-3 px-6 rounded-lg bg-gray-900 text-white shadow-md shadow-gray-900/10 hover:shadow-lg hover:shadow-gray-900/20 focus:opacity-[0.85] focus:shadow-none active:opacity-[0.85] active:shadow-none"
                type="button" onclick="Fun_save(this)"><?php if($_GET['id'] ?? '' && $_GET['id'] != '') {echo "Update"; }else {echo "Save"; }?></button>
                </div>
            </p>
        </div>
    <div class="w-full relative overflow-x-auto shadow-md sm:rounded-lg mt-4">
            <table class="w-full text-sm text-left rtl:text-right text-gray-500 darks:text-gray-400">
                <thead class="text-xs text-gray-700 uppercase bg-gray-50 darks:bg-gray-700 darks:text-gray-400 sticky top-0">
                    <tr>
                        <th scope="col" class="px-6 py-3">
                            Role name
                        </th>
                        <th scope="col" class="px-6 py-3">
                            Modify
                        </th>
                    </tr>
                </thead>
                <tbody class="overflow-y-auto" id="getAddModifyGroup">
                    @if(count($result) > 0)
                        @foreach ($result as $items)
                        <tr class="odd:bg-white odd:darks:bg-gray-900 even:bg-gray-50 even:darks:bg-gray-800 border-b darks:border-gray-700">
                            <th scope="row" class="px-6 py-3 font-medium text-gray-900 whitespace-nowrap darks:text-white">
                                {{$items->roles_name}}
                            </th>
                            <td class="px-6 py-3 cursor-pointer">
                            <button Onclick="Fun_edit({{$items->id}})" class="select-none rounded-lg bg-gray-900 py-1 px-4 text-center align-middle font-sans text-xs font-bold text-white shadow-md shadow-gray-900/10 transition-all hover:shadow-lg hover:shadow-gray-900/20 focus:opacity-[0.85] focus:shadow-none active:opacity-[0.85] active:shadow-none disabled:pointer-events-none disabled:opacity-50 disabled:shadow-none" type="button">
                                Edit
                            </button>
                            </td>
                        </tr>
                        @endforeach
                    @else
                        <tr class="odd:bg-white odd:darks:bg-gray-900 even:bg-gray-50 even:darks:bg-gray-800 border-b darks:border-gray-700">
                            <th colspan="2" scope="row" class="text-center text-zinc-400 px-6 py-3 font-medium text-gray-900 whitespace-nowrap darks:text-white">
                                No data available in table
                            </th>
                        </tr>
                    @endif
                </tbody>
            </table>
        </div>
    </div>
</div>

<script>
    function Fun_save(event) {

        var checker = $(event).text();
        if(checker == 'Save') {
            var name = $('#GroupName').val();
            if(name == '') {
                alert('Please Enter Name....');
            }else {
                $.ajax({
                    type: "post",
                    url: "{{ route('autonomous-level') }}",
                    headers: {
                        'X-CSRF-TOKEN': '{{ csrf_token() }}'
                    },
                    data: {
                        ref: 'Group_Management',
                        name: name
                    },
                    success: function(result) {
                        if(result.message) {
                            $('#GroupName').val('');
                            alert(result.message);
                            location.reload();
                            // getdata_group()
                        }
                    }
                })
            }
        }else if(checker == 'Update') {
            var name = $('#GroupName').val();
            if(name == '') {
                alert('Please Enter Name....');
            }else {
                $.ajax({
                    type: "post",
                    url: "{{ route('autonomous-level') }}",
                    headers: {
                        'X-CSRF-TOKEN': '{{ csrf_token() }}'
                    },
                    data: {
                        ref: 'Group_Management_update',
                        name: name,
                        idss: '<?php echo $_GET['id'] ?? ''; ?>'
                    },
                    success: function(result) {
                        if(result.message) {
                            $('#GroupName').val('');
                            alert(result.message);
                            location.replace('https://smarthub.rn-test.com/departments');
                        }
                    }
                })
            }
        }
    }

    function Fun_edit(id) {
        window.location.href = 'https://smarthub.rn-test.com/departments?id='+id;
    }
</script>
<!-- -------------------------- Add/ Modify Group --------------------------- -->


<!-- -------------------------- Associate user with group --------------------------- -->


<div class="relative flex flex-col mt-6 text-gray-700 bg-white shadow-md bg-clip-border rounded-xl w-1/2 overflow-y-auto">
    <div class="p-6 w-full" style="height: 26.5rem;">
        <h5 class="block mb-2 font-sans text-xl antialiased font-semibold leading-snug tracking-normal text-blue-gray-900">
        Associate user with department&nbsp; <span style="color: red;">*</span>
        </h5>
        <p class="block font-sans text-base antialiased font-light leading-relaxed text-inherit">
            <div class="w-auto flex items-center gap-4">
                <div class="relative h-10 w-full min-w-[200px] flex gap-2">
                    <select id="select_id" class="peer h-full w-full rounded-[7px]  !border  !border-gray-300 border-t-transparent bg-transparent bg-white px-3 py-2.5 font-sans text-sm font-normal text-blue-gray-700  shadow-lg shadow-gray-900/5 outline outline-0 ring-4 ring-transparent transition-all placeholder:text-gray-500 placeholder-shown:border placeholder-shown:border-blue-gray-200 placeholder-shown:border-t-blue-gray-200 focus:border-2  focus:!border-gray-900 focus:border-t-transparent focus:!border-t-gray-900 focus:outline-0 focus:ring-gray-900/10 disabled:border-0 disabled:bg-blue-gray-50" >
                        <option selected="" value="">Select group</option>
                        @foreach ($GROUPlist as $data)
                                <option value="{{$data->id}}" <?php if($data->roles_name == ($Associate_list[0]->roles_name ?? '')) {echo "selected";}?>>{{$data->roles_name}}</option>
                        @endforeach
                    </select>
                    <div x-data="multiSelectDropdown()" class="relative w-full" @click.outside="open = false">
                    <!-- Input Box -->
                    <input type="text" placeholder="Select Member"
                        x-model="search"
                        @focus="open = true"
                        @input="filterList"
                        class="peer h-full w-full rounded-[7px] border border-gray-300 bg-white px-3 py-2.5 font-sans text-sm text-blue-gray-700 shadow-lg outline-none transition-all placeholder:text-gray-500 focus:border-gray-900 focus:ring-gray-900/10"
                    />

                    <!-- Display Selected Members -->
                    <div x-show="selectedUsers.length > 0" class="mt-2 flex flex-wrap z-20 relative border border-gray-300 rounded-lg shadow-md" style="background-color: white; padding: 10px;">
                        <span class="font-semibold">Selected Members:</span>
                        <template x-for="(user, index) in selectedUsers" :key="index">
                            <span class="inline-flex items-center bg-blue-500 text-white rounded-full py-1 px-3 mr-2 mt-1 text-sm">
                                <span x-text="user"></span>
                                <button type="button" @click="removeSelection(user)" class="ml-1 text-white hover:text-gray-300">&times;</button>
                            </span>
                        </template>
                    </div>

                    <input type="text" id="tags" x-bind:value="selectedUsers.join(', ')" class="hidden">

                    <!-- Dropdown (Only Show After Typing) -->
                    <div x-show="open && search.trim() !== ''" class="absolute z-10 w-full bg-white border border-gray-300 rounded shadow-md max-h-60 overflow-y-auto mt-1 p-2">
                        <template x-for="(user, index) in filteredList" :key="index">
                            <label class="flex items-center p-2 hover:bg-gray-100 cursor-pointer">
                                <input type="checkbox" class="mr-2" :value="user.user_name" :checked="selectedUsers.includes(user.user_name)"
                                    @change="toggleSelection(user.user_name)">
                                <span x-text="user.user_name"></span>
                            </label>
                        </template>
                    </div>
                </div>

                <script>
                    document.addEventListener('alpine:init', () => {
                        Alpine.data('multiSelectDropdown', () => ({
                            open: false,
                            search: "",
                            selectedUsers: @json(is_array($member_lists) ? $member_lists : ($member_lists ? explode(', ', $member_lists) : [])), // Convert string to array
                            associateList: @json($Associate_lists),
                            filteredList: @json($Associate_lists),

                            filterList() {
                                if (this.search.trim() === '') {
                                    this.filteredList = this.associateList;
                                } else {
                                    this.filteredList = this.associateList.filter(user =>
                                        user.user_name.toLowerCase().includes(this.search.toLowerCase())
                                    );
                                }
                            },

                            toggleSelection(user) {
                                if (this.selectedUsers.includes(user)) {
                                    this.selectedUsers = this.selectedUsers.filter(n => n !== user);
                                } else {
                                    this.selectedUsers.push(user);
                                }
                                this.search = "";
                            },

                            removeSelection(user) {
                                this.selectedUsers = this.selectedUsers.filter(n => n !== user);
                                this.search = "";
                            },
                        }));
                    });
                </script>
                <style>
                .max-h-60 {
                    max-height: 200px;
                    overflow-y: auto;
                    display: flex;
                    flex-direction: column;
                }
            </style>
                </div>
                <button
            class="align-middle select-none font-sans font-bold text-center uppercase transition-all disabled:opacity-50 disabled:shadow-none disabled:pointer-events-none text-xs py-3 px-6 rounded-lg bg-gray-900 text-white shadow-md shadow-gray-900/10 hover:shadow-lg hover:shadow-gray-900/20 focus:opacity-[0.85] focus:shadow-none active:opacity-[0.85] active:shadow-none"
            type="button" onclick="Fun_save1(this)"><?php if($_GET['ids'] ?? '' && $_GET['ids'] != '') {echo "Update"; }else {echo "Save"; }?></button>
            </div>
        </p>

    <div class="w-full relative overflow-x-auto shadow-md sm:rounded-lg mt-4">
            <table class="w-full text-sm text-left rtl:text-right text-gray-500 darks:text-gray-400">
                <thead class="text-xs text-gray-700 uppercase bg-gray-50 darks:bg-gray-700 darks:text-gray-400 sticky top-0">
                    <tr>
                        <th scope="col" class="px-6 py-3">
                        Department Name
                        </th>
                        <th scope="col" class="px-6 py-3">
                            Users
                        </th>
                        <th scope="col" class="px-6 py-3">
                            Modify
                        </th>
                    </tr>
                </thead>
                <tbody class="overflow-y-auto" id="getAssociate">
                    @if(count($result1) > 0)
                        @foreach ($result1 as $items)
                        <tr class="odd:bg-white odd:darks:bg-gray-900 even:bg-gray-50 even:darks:bg-gray-800 border-b darks:border-gray-700">
                            <th scope="row" class="px-6 py-3 font-medium text-gray-900 whitespace-nowrap darks:text-white">
                                {{$items->roles_name}}
                            </th>
                            <td class="px-6 py-3">
                                {{$items->user_name}}
                            </td>
                            <td class="px-6 py-3 cursor-pointer">
                            <button Onclick="Associate_edit('{{$items->id}}')" class="select-none rounded-lg bg-gray-900 py-1 px-4 text-center align-middle font-sans text-xs font-bold text-white shadow-md shadow-gray-900/10 transition-all hover:shadow-lg hover:shadow-gray-900/20 focus:opacity-[0.85] focus:shadow-none active:opacity-[0.85] active:shadow-none disabled:pointer-events-none disabled:opacity-50 disabled:shadow-none" type="button">
                                Edit
                            </button>
                            </td>
                        </tr>
                        @endforeach
                    @else
                        <tr class="odd:bg-white odd:darks:bg-gray-900 even:bg-gray-50 even:darks:bg-gray-800 border-b darks:border-gray-700">
                            <th colspan="3" scope="row" class="text-center text-zinc-400 px-6 py-3 font-medium text-gray-900 whitespace-nowrap darks:text-white">
                                No data available in table
                            </th>
                        </tr>
                    @endif
                </tbody>
            </table>
        </div>
    </div>
    </div>

    <script>

    $(function() {
        var availableTags = @json($stafflist1).map(e=>e.name);
        $( "#tags" ).autocomplete({
            source: availableTags
        });
    });

    function Associate_edit(id) {
        // alert(id)
        location.replace('https://smarthub.rn-test.com/departments?ids='+id); 
    }
      

    function Fun_save1(text) {
        var textz = $(text).text();
        if(textz == 'Save') {
            var team = $('#select_id').val();
            // var user = $('#tags').val();
            var user = document.getElementById('tags').value;

            if(team == '') {
                alert('Select Team....');
            }else if(user == '') {
                alert('Serach Member....');
            }else {
                $.ajax({
                    type: "post",
                    url: "{{ route('autonomous-level') }}",
                    headers: {
                        'X-CSRF-TOKEN': '{{ csrf_token() }}'
                    },
                    data: {
                        ref: 'Associate_user',
                        team: team,
                        user: user
                    },
                    success: function(result) {
                        if(result.message) {
                            $('#select_id').val('');
                            $('#tags').val('');
                            alert(result.message);
                            // window.location.replace('https://smarthub.rn-test.com/departments');

                            location.reload();
                            // getdata();
                        }
                    }
                })
            }
        }
        else if(textz == 'Update') {
            var team = $('#select_id').val();
            // var user = $('#tags').val();
            var user = document.getElementById('tags').value;

            if(team == '') {
                alert('Select Team....');
            }else if(user == '') {
                alert('Serach Member....');
            }else {
                $.ajax({
                    type: "post",
                    url: "{{ route('autonomous-level') }}",
                    headers: {
                        'X-CSRF-TOKEN': '{{ csrf_token() }}'
                    },
                    data: {
                        ref: 'Associate_user_update',
                        team: team,
                        user: user,
                        idss: '<?php echo $_GET['ids'] ?? ''; ?>'
                    },
                    success: function(result) {
                        if(result.message) {
                            $('#select_id').val('');
                            $('#tags').val('');
                            alert(result.message);
                            location.replace('https://smarthub.rn-test.com/departments');
                        }
                    }
                })
            }
        }



    }

    // function getdata() {
    //     $.ajax({
    //         type: "post",
    //         url: "{{ route('autonomous-level') }}",
    //         headers: {
    //             'X-CSRF-TOKEN': '{{ csrf_token() }}'
    //         },
    //         data: {
    //             ref: 'getelement',
    //         },
    //         success: function(result) {
    //             $('#getAssociate').html('');
    //             for (let i = 0; i < result.message.length; i++) {
    //                 var tablerow = `
    //                 <tr class="odd:bg-white odd:darks:bg-gray-900 even:bg-gray-50 even:darks:bg-gray-800 border-b darks:border-gray-700">
    //                     <th scope="row" class="px-6 py-3 font-medium text-gray-900 whitespace-nowrap darks:text-white">
    //                     `+result.message[i].groupname+`
    //                     </th>
    //                     <td class="px-6 py-3">
    //                         `+result.message[i].user_name+`
    //                     </td>
    //                     <td class="px-6 py-3 cursor-pointer">
    //                     <button Onclick="Associate_edit(`+result.message[i].id+`)" class="select-none rounded-lg bg-gray-900 py-1 px-4 text-center align-middle font-sans text-xs font-bold text-white shadow-md shadow-gray-900/10 transition-all hover:shadow-lg hover:shadow-gray-900/20 focus:opacity-[0.85] focus:shadow-none active:opacity-[0.85] active:shadow-none disabled:pointer-events-none disabled:opacity-50 disabled:shadow-none" type="button">
    //                         Edit
    //                     </button>
    //                     </td>  
    //                 </tr>
    //                 `;
    //                 $('#getAssociate').append(tablerow);
    //             }
    //         }
    //     })
    // }


    // function getdata_group() {
    //     $.ajax({
    //         type: "post",
    //         url: "{{ route('autonomous-level') }}",
    //         headers: {
    //             'X-CSRF-TOKEN': '{{ csrf_token() }}'
    //         },
    //         data: {
    //             ref: 'getgroup',
    //         },
    //         success: function(result) {
    //             $('#getAddModifyGroup').html('');
    //             for (let i = 0; i < result.message.length; i++) {
    //                 var tablerow = `
    //                 <tr class="odd:bg-white odd:darks:bg-gray-900 even:bg-gray-50 even:darks:bg-gray-800 border-b darks:border-gray-700">
    //                     <th scope="row" class="px-6 py-3 font-medium text-gray-900 whitespace-nowrap darks:text-white">
    //                         `+result.message[i].groupname+`
    //                     </th>
    //                     <td class="px-6 py-3 cursor-pointer">
    //                     <button Onclick="Fun_edit(`+result.message[i].id+`)" class="select-none rounded-lg bg-gray-900 py-1 px-4 text-center align-middle font-sans text-xs font-bold text-white shadow-md shadow-gray-900/10 transition-all hover:shadow-lg hover:shadow-gray-900/20 focus:opacity-[0.85] focus:shadow-none active:opacity-[0.85] active:shadow-none disabled:pointer-events-none disabled:opacity-50 disabled:shadow-none" type="button">
    //                         Edit
    //                     </button>
    //                     </td>
    //                 </tr>
    //                 `;
    //                 $('#getAddModifyGroup').append(tablerow);
    //             }
    //         }
    //     })
    // }

    </script>
    </div>
    
</div>
@endsection 