@extends('header.topnav')

@section('title', 'Welcome')

@section('content')

    <head>
        <script src="{{ asset('js/flowbite.min.js') }}"></script>
        <script src="https://cdn.jsdelivr.net/npm/apexcharts"></script>
        <style>
            .apexcharts-toolbar .apexcharts-menu {
                width: 115px;
            }
        </style>
    </head>

    <div class="p-8 overflow-y-auto" style="height: 40rem;">
        <div class="flex items-center gap-1 w-full">
            <h1 class="text-2xl font-bold">Buiest Times</h1>
            {{-- <svg data-popover-target="chart-info" data-popover-placement="bottom"
                class="w-3.5 h-3.5 text-gray-500 dark:text-gray-400 hover:text-gray-900 dark:hover:text-white cursor-pointer ms-1"
                aria-hidden="true" xmlns="http://www.w3.org/2000/svg" fill="currentColor" viewBox="0 0 20 20">
                <path
                    d="M10 .5a9.5 9.5 0 1 0 9.5 9.5A9.51 9.51 0 0 0 10 .5Zm0 16a1.5 1.5 0 1 1 0-3 1.5 1.5 0 0 1 0 3Zm1-5.034V12a1 1 0 0 1-2 0v-1.418a1 1 0 0 1 1.038-.999 1.436 1.436 0 0 0 1.488-1.441 1.501 1.501 0 1 0-3-.116.986.986 0 0 1-1.037.961 1 1 0 0 1-.96-1.037A3.5 3.5 0 1 1 11 11.466Z" />
            </svg> --}}
            <div data-popover id="chart-info" role="tooltip"
                class="absolute z-10 invisible inline-block text-sm text-gray-500 transition-opacity duration-300 bg-white border border-gray-200 rounded-lg shadow-sm opacity-0 w-72 dark:bg-gray-800 dark:border-gray-600 dark:text-gray-400">
                <div class="p-3 space-y-2">
                    <h3 class="font-semibold text-gray-900 dark:text-white">Activity growth - Incremental</h3>
                    <p>Report helps navigate cumulative growth of community activities. Ideally, the chart should have a
                        growing trend, as stagnating chart signifies a significant decrease of community activity.</p>
                </div>
                <div data-popper-arrow></div>
            </div>
        </div>
        <br>
        <div class="flex items-center justify-between w-11/12">
            <div class="flex items-center gap-3">
                <div class="w-96">
                    <select id="countries" onchange="selet(this)"
                        class="peer h-full w-full rounded-[7px]  !border  !border-gray-300 border-t-transparent bg-transparent bg-white px-3 py-2.5 font-sans text-sm font-normal text-blue-gray-700  shadow-lg shadow-gray-900/5 outline outline-0 ring-4 ring-transparent transition-all placeholder:text-gray-500 placeholder-shown:border placeholder-shown:border-blue-gray-200 placeholder-shown:border-t-blue-gray-200 focus:border-2  focus:!border-gray-900 focus:border-t-transparent focus:!border-t-gray-900 focus:outline-0 focus:ring-gray-900/10 disabled:border-0 disabled:bg-blue-gray-50">
                        <option value="all" selected>Messages All</option>
                        <option value="sent">Messages sent</option>
                        <option value="received">Messages received</option>
                    </select>
                </div>
                <input type="week" placeholder="Select week" onchange="moveee(this)"
                    class="peer h-full w-96 rounded-[7px]  !border  !border-gray-300 border-t-transparent bg-transparent bg-white px-3 py-2.5 font-sans text-sm font-normal text-blue-gray-700  shadow-lg shadow-gray-900/5 outline outline-0 ring-4 ring-transparent transition-all placeholder:text-gray-500 placeholder-shown:border placeholder-shown:border-blue-gray-200 placeholder-shown:border-t-blue-gray-200 focus:border-2  focus:!border-gray-900 focus:border-t-transparent focus:!border-t-gray-900 focus:outline-0 focus:ring-gray-900/10 disabled:border-0 disabled:bg-blue-gray-50">
            </div>
            <div class="flex items-center gap-2">
                <span>0</span>
                <div class="h-3 rounded-sm w-full bg-gradient-to-r from-red-600 via-orange-500 to-green-800" style="height: 1rem;width: 12rem"></div>
                <span>375</span>
            </div>
        </div>
        <br>
        <div class="flex items-start gap-20">
            <div class=" w-8/12 h-96 overflow-y-auto">
                <div id="chart"></div>
                <table id="thade" class="!hidden w-full text-sm text-center rtl:text-right text-gray-500 h-full">
                    <thead>
                        <tr>
                            <th scope="col" class="px-1 py-3 border-0 sticky top-0 bg-white"></th>
                            <th scope="col" class="px-1 py-3  border-0 sticky top-0 bg-white">Mon</th>
                            <th scope="col" class="px-1 py-3 border-0 sticky top-0 bg-white">Tue</th>
                            <th scope="col" class="px-1 py-3 border-0 sticky top-0 bg-white">Wen</th>
                            <th scope="col" class="px-1 py-3 border-0 sticky top-0 bg-white">Thu</th>
                            <th scope="col" class="px-1 py-3 border-0 sticky top-0 bg-white">Fri</th>
                        </tr>
                    </thead>
                    <tbody class="overflow-y-auto" id="heatmaptab">
                        <?php
                        // $arrayResult = [];
                        // foreach (json_decode($result, true) as $stdClassObject) {
                        //     $arrayResult[] = (array) $stdClassObject;
                        // }
                        ?>
                        {{-- @foreach ($result as $items)
                           
                                <tr>
                                <td class="border-8 border-white rounded-xl">'. $items->time .'</td>
            
                                <td class=" font-bold border-8 border-white rounded-xl " style="
                                if ($items->mon > 347) {
                                    $html .= 'background: #dd3c00;color:#fff;';
                                } elseif ($items->mon > 250) {
                                    $html .= 'background: #ff5800;color:#fff;';
                                } elseif ($items->mon > 100) {
                                    $html .= 'background: #ffe9d1;color:#e5622e;';
                                } elseif ($items->mon > 10) {
                                    $html .= 'background: #fff7f0;color:#e5622e;';
                                } 
                                $html .= ' ">'. $items->mon .'</td>
            
                                <td class=" font-bold border-8 border-white rounded-xl " style="';
                                if ($items->tue > 347) {
                                    $html .= 'background: #dd3c00;color:#fff;';
                                } elseif ($items->tue > 250) {
                                    $html .= 'background: #ff5800;color:#fff;';
                                } elseif ($items->tue > 100) {
                                    $html .= 'background: #ffe9d1;color:#e5622e;';
                                } elseif ($items->tue > 10) {
                                    $html .= 'background: #fff7f0;color:#e5622e;';
                                } 
                                $html .= '">
                                    '.$items->tue .'</td>
            
                                <td class=" font-bold border-8 border-white rounded-xl " style="';
                                if ($items->wed > 347) {
                                    $html .= 'background: #dd3c00;color:#fff;';
                                } elseif ($items->wed > 250) {
                                    $html .= 'background: #ff5800;color:#fff;';
                                } elseif ($items->wed > 100) {
                                    $html .= 'background: #ffe9d1;color:#e5622e;';
                                } elseif ($items->wed > 10) {
                                    $html .= 'background: #fff7f0;color:#e5622e;';
                                } 
                                $html .= '">
                                    '.$items->wed .'</td>
            
                                <td class=" font-bold border-8 border-white rounded-xl " style="';
                                 if ($items->thu > 347) {
                                    $html .= 'background: #dd3c00;color:#fff;';
                                } elseif ($items->thu > 250) {
                                    $html .= 'background: #ff5800;color:#fff;';
                                } elseif ($items->thu > 100) {
                                    $html .= 'background: #ffe9d1;color:#e5622e;';
                                } elseif ($items->thu > 10) {
                                    $html .= 'background: #fff7f0;color:#e5622e;';
                                } 
                                $html .= '">'.$items->thu .'</td>
            
                                <td class=" font-bold border-8 border-white rounded-xl " style="';
                                 if ($items->fri > 347) {
                                    $html .= 'background: #dd3c00;color:#fff;';
                                } elseif ($items->fri > 250) {
                                    $html .= 'background: #ff5800;color:#fff;';
                                } elseif ($items->fri > 100) {
                                    $html .= 'background: #ffe9d1;color:#e5622e;';
                                } elseif ($items->fri > 10) {
                                    $html .= 'background: #fff7f0;color:#e5622e;';
                                } 
                                $html .= '">'.$items->fri .'</td>
                            </tr>
                            @endforeach --}}
                    </tbody>
                </table>
            </div>
            <div class="space-y-6 ">
                <h1 class="text-base font-semibold" style="color: #868c97;">Top Times</h1>
                <div>
                    <h1 class="text-xl font-semibold" style="color: #4f4f50;">Friday, 10 AM - 11 AM</h1>
                    <div style="color:#b0b1b2;" id="first">433 messages sent</div>
                </div>
                <div>
                    <h1 class="text-xl font-semibold" style="color: #4f4f50;">Monday, 3 PM - 4 PM</h1>
                    <div style="color:#b0b1b2;" id="second">357 messages sent</div>
                </div>
                <div>
                    <h1 class="text-xl font-semibold" style="color: #4f4f50;">Tuesday, 11 AM - 12 PM</h1>
                    <div style="color:#b0b1b2;" id="three">354 messages sent</div>
                </div>
                <div>
                    <h1 class="text-xl font-semibold" style="color: #4f4f50;">Tuesday, 10 AM - 11 AM</h1>
                    <div style="color:#b0b1b2;" id="four">346 messages sent</div>
                </div>
            </div>
        </div>
    </div>
    <script>
        // heattable('All');



        var filteredData = @json($result);
        console.log('ddddata', filteredData);

        // var filteredData = data.filter(record => {
        //     // Extract the hour from the time string
        //     var hour = parseInt(record.time.split(' ')[0]);
        //     // Check if the hour is between 8 AM and 6 PM (exclusive)
        //     return hour >= 8 && hour < 18;
        // });

console.table('filteredData',filteredData);
        function generateData(count, jsondata, dayname, yrange) {
            var i = 0;
            var series = [];
            while (i < count) {
                var x = jsondata[i] == undefined ? 0 : jsondata[i].time.toString();
                var y = jsondata[i][dayname];
                series.push({
                    x: x,
                    y: y
                });
                i++;
            }
            return series;
        }

        var options = {
            chart: {
                height: 350,
                type: "heatmap",
                toolbar: {
                    show: true,
                },
            },
            legend: {
                show: false,
            },
            plotOptions: {
                heatmap: {
                    enableShades: false,
                    radius: 4,
                    colorScale: {
                        ranges: [{
                                from: -30,
                                to: 0,
                                color: '#dc2626',
                                name: 'low',
                            },
                            {
                                from: 1,
                                to: 1,
                                color: '#CF3939',
                                name: 'medium',
                            },
                            {
                                from: 2,
                                to: 2,
                                color: '#CF7272',
                                name: 'high',
                            },
                            {
                                from: 3,
                                to: 3,
                                color: '#D49D9D',
                                name: 'high',
                            },
                            {
                                from: 4,
                                to: 4,
                                color: '#dd3c00',
                                name: 'high',
                            },
                            {
                                from: 5,
                                to: 5,
                                color: '#f97316',
                                name: 'high',
                            },
                            {
                                from: 6,
                                to: 6,
                                color: '#FB9F5E',
                                name: 'high',
                            },
                            {
                                from: 7,
                                to: 7,
                                color: '#F7BC92',
                                name: 'high',
                            },
                            {
                                from: 8,
                                to: 8,
                                color: '#71DC71',
                                name: 'high',
                            },
                            {
                                from: 9,
                                to: 9,
                                color: '#22C522',
                                name: 'high',
                            },
                            {
                                from: 10,
                                to: 10,
                                color: '#079707cf',
                                name: 'high',
                            },
                            {
                                from: 11,
                                to: 11,
                                color: '#008000',
                                name: 'high',
                            }
                        ],
                    }
                }
            },
            dataLabels: {
                enabled: true,
                style: {
                    colors: ['#000'] // Customize the colors here
                }
            },
            series: [{
                    name: "Monday",
                    data: generateData(filteredData.length, filteredData, "mon", {
                        min: -30,
                        max: 55
                    })
                },
                {
                    name: "Tuesday",
                    data: generateData(filteredData.length, filteredData, "tue", {
                        min: -30,
                        max: 55
                    })
                },
                {
                    name: "Wednesday",
                    data: generateData(filteredData.length, filteredData, "wed", {
                        min: -30,
                        max: 55
                    })
                },
                {
                    name: "Thursday",
                    data: generateData(filteredData.length, filteredData, "thu", {
                        min: -30,
                        max: 55
                    })
                },
                {
                    name: "Friday",
                    data: generateData(filteredData.length, filteredData, "fri", {
                        min: -30,
                        max: 55
                    })
                }
            ],
            tooltip: {
                enabled: false,
                custom: function({
                    series,
                    seriesIndex,
                    dataPointIndex,
                    w
                }) {
                    if (w.globals.seriesNames[seriesIndex] !== "") {
                        return series[seriesIndex][dataPointIndex];
                    } else {
                        return "";
                    }
                }
            },
            plugins: [{
                id: 'customBeforeDraw',
                beforeDraw: function(chartContext, config) {
                    console.log('Before drawing the chart!'); // Your custom logic here
                }
            }]
        };

        var chart = new ApexCharts(document.querySelector("#chart"), options);
        chart.render();

        function heattable(tag) {
            $.ajax({
                type: 'post',
                url: "{{ route('autonomous-level') }}",
                headers: {
                    'X-CSRF-TOKEN': '{{ csrf_token() }}'
                },
                data: {
                    ref: "GetHeatmap",
                    option: tag
                },
                success: function(result) {
                    console.log('11result', result.result)
                    // var data = result.result;
                    const filteredData1 = result.result;

                    function filterRecords(records) {
                        // Filtered records array
                        var filteredRecords = [];

                        // Iterate through each record
                        records.forEach(function(record) {
                            // Extract the hour from the time string
                            var hour = parseInt(record.time.split(" ")[0]);

                            // Check if the hour is between 8 AM and 6 PM (inclusive)
                            if (hour >= 8 && hour < 18) {
                            // Add the record to the filtered array
                            filteredRecords.push(record);
                            }
                        });

                        return filteredRecords;
                    }
                    // var filteredData1 = filterRecords(scheduleData1);

                    // console.log('filteredData',filteredData1);

                    // const filteredData1 = scheduleData1.filter((item) => {
                    //     const time = item.time;
                    //     const hour = parseInt(time.split(' ')[0], 10);
                    //     const isAM = time.includes('AM');
                    //     let hourIn24Format;

                    //     if (isAM) {
                    //         hourIn24Format = hour;
                    //     } else {
                    //         hourIn24Format = hour + 12;
                    //     }

                    //     return hourIn24Format >= 8 && hourIn24Format <= 18;
                    // });
                    // var filteredData1 = data.filter(function(item) {
                    //     return !(item.mon === 0 && item.tue === 0 && item.wed === 0 && item.thu === 0 &&
                    //         item.fri === 0);
                    // });
                    // console.log('1filteredData', filteredData1);
                    chart.updateSeries([{
                            name: "Monday",
                            data: generateData(filteredData1.length, filteredData1, "mon", {
                                min: -30,
                                max: 55
                            }),
                            group: 'apexcharts-axis-0'
                        },
                        {
                            name: "Tuesday",
                            data: generateData(filteredData1.length, filteredData1, "tue", {
                                min: -30,
                                max: 55
                            }),
                            group: 'apexcharts-axis-0'
                        },
                        {
                            name: "Wednesday",
                            data: generateData(filteredData1.length, filteredData1, "wed", {
                                min: -30,
                                max: 55
                            }),
                            group: 'apexcharts-axis-0'
                        },
                        {
                            name: "Thursday",
                            data: generateData(filteredData1.length, filteredData1, "thu", {
                                min: -30,
                                max: 55
                            }),
                            group: 'apexcharts-axis-0'
                        },
                        {
                            name: "Friday",
                            data: generateData(filteredData1.length, filteredData1, "fri", {
                                min: -30,
                                max: 55
                            }),
                            group: 'apexcharts-axis-0'
                        }
                    ]);
                    // console.log('sdfsdf', generateData(filteredData1.length, filteredData1, "fri", {
                    //     min: -30,
                    //     max: 55
                    // }))
                    var ttttt = generateData(filteredData1.length, filteredData1, "fri", {
                        min: -30,
                        max: 55
                    });
                    const modifiedData = ttttt.map(item => {
                        const xValue = item.x.replace(" AM", "").replace(" PM", "");
                        return {
                            ...item,
                            x: xValue
                        };
                    });

                    let first = [];
                    let second = [];
                    let three = [];
                    let four = [];
                    modifiedData.forEach(element => {
                        if (element.x >= 10 && element.x <= 11) {
                            first.push(element.y);
                            $('#first').text(Math.max(...first) + ' messages sent');
                        }
                    })

                    var ttttt1 = generateData(filteredData1.length, filteredData1, "mon", {
                        min: -30,
                        max: 55
                    });
                    const modifiedData1 = ttttt1.map(item => {
                        const xValue = item.x.replace(" AM", "").replace(" PM", "");
                        return {
                            ...item,
                            x: xValue
                        };
                    });

                    modifiedData1.forEach(element => {

                        if (element.x >= 3 && element.x <= 4) {
                            second.push(element.y);
                            $('#second').text(Math.max(...second) + ' messages sent');
                        }

                    })

                    var ttttt2 = generateData(filteredData1.length, filteredData1, "tue", {
                        min: -30,
                        max: 55
                    });
                    const modifiedData2 = ttttt2.map(item => {
                        const xValue = item.x.replace(" AM", "").replace(" PM", "");
                        return {
                            ...item,
                            x: xValue
                        };
                    });


                    modifiedData2.forEach(element => {

                        if (element.x >= 11 && element.x <= 12) {
                            $('#three').text(Math.max(...second) + ' messages sent');
                        }

                    })

                    var ttttt3 = generateData(filteredData1.length, filteredData1, "wed", {
                        min: -30,
                        max: 55
                    });
                    const modifiedData3 = ttttt3.map(item => {
                        const xValue = item.x.replace(" AM", "").replace(" PM", "");
                        return {
                            ...item,
                            x: xValue
                        };
                    });


                    modifiedData3.forEach(element => {

                        if (element.x >= 10 && element.x <= 11) {
                            // console.log('dsfsd', element.x)
                            $('#four').text(Math.max(...second) + ' messages sent');
                        }
                    })
                }
            })
        }
        heattable('All');

        function selet(e) {

            heattable(e.value);
        }


        function moveee(event) {
            console.log('event', event.value);
            const inputString = event.value;
            let year = '';
            let week = '';

            const parts = inputString.split("-");

            if (parts.length === 2 && parts[0].length === 4 && parts[1].startsWith("W")) {
                year = parts[0];
                week = parts[1].substring(1);
            }

            $.ajax({
                type: 'post',
                url: "{{ route('autonomous-level') }}",
                headers: {
                    'X-CSRF-TOKEN': '{{ csrf_token() }}'
                },
                data: {
                    ref: "GetHeatmap_chd",
                    year: year,
                    week: week
                },
                success: function(result) {
                    var data = result.result;
                    console.log('sfrgsfg', data)
                    // var filteredData1 = data.filter(function(item) {
                    //     return !(item.mon === 0 && item.tue === 0 && item.wed === 0 && item.thu === 0 &&
                    //         item.fri === 0);
                    // });

                    const filteredData1 = result.result;

                    // const filteredData1 = scheduleData1.filter((item) => {
                    //     const time = item.time;
                    //     const hour = parseInt(time.split(' ')[0], 10);
                    //     const isAM = time.includes('AM');
                    //     let hourIn24Format;

                    //     if (isAM) {
                    //         hourIn24Format = hour;
                    //     } else {
                    //         hourIn24Format = hour + 12;
                    //     }

                    //     return hourIn24Format >= 8 && hourIn24Format <= 18;
                    // });

                    // console.log('1filteredData', filteredData1);
                    chart.updateSeries([{
                            name: "Monday",
                            data: generateData(filteredData1.length, filteredData1, "mon", {
                                min: -30,
                                max: 55
                            }),
                            group: 'apexcharts-axis-0'
                        },
                        {
                            name: "Tuesday",
                            data: generateData(filteredData1.length, filteredData1, "tue", {
                                min: -30,
                                max: 55
                            }),
                            group: 'apexcharts-axis-0'
                        },
                        {
                            name: "Wednesday",
                            data: generateData(filteredData1.length, filteredData1, "wed", {
                                min: -30,
                                max: 55
                            }),
                            group: 'apexcharts-axis-0'
                        },
                        {
                            name: "Thursday",
                            data: generateData(filteredData1.length, filteredData1, "thu", {
                                min: -30,
                                max: 55
                            }),
                            group: 'apexcharts-axis-0'
                        },
                        {
                            name: "Friday",
                            data: generateData(filteredData1.length, filteredData1, "fri", {
                                min: -30,
                                max: 55
                            }),
                            group: 'apexcharts-axis-0'
                        }
                    ]);
                    // console.log('sdfsdf', generateData(filteredData1.length, filteredData1, "fri", {
                    //     min: -30,
                    //     max: 55
                    // }))
                    var ttttt = generateData(filteredData1.length, filteredData1, "fri", {
                        min: -30,
                        max: 55
                    });
                    const modifiedData = ttttt.map(item => {
                        const xValue = item.x.replace(" AM", "").replace(" PM", "");
                        return {
                            ...item,
                            x: xValue
                        };
                    });

                    let first = [];
                    let second = [];
                    let three = [];
                    let four = [];
                    modifiedData.forEach(element => {
                        if (element.x >= 10 && element.x <= 11) {
                            first.push(element.y);
                            $('#first').text(Math.max(...first) + ' messages sent');
                        }
                    })

                    var ttttt1 = generateData(filteredData1.length, filteredData1, "mon", {
                        min: -30,
                        max: 55
                    });
                    const modifiedData1 = ttttt1.map(item => {
                        const xValue = item.x.replace(" AM", "").replace(" PM", "");
                        return {
                            ...item,
                            x: xValue
                        };
                    });

                    modifiedData1.forEach(element => {

                        if (element.x >= 3 && element.x <= 4) {
                            second.push(element.y);
                            $('#second').text(Math.max(...second) + ' messages sent');
                        }

                    })

                    var ttttt2 = generateData(filteredData1.length, filteredData1, "tue", {
                        min: -30,
                        max: 55
                    });
                    const modifiedData2 = ttttt2.map(item => {
                        const xValue = item.x.replace(" AM", "").replace(" PM", "");
                        return {
                            ...item,
                            x: xValue
                        };
                    });


                    modifiedData2.forEach(element => {

                        if (element.x >= 11 && element.x <= 12) {
                            $('#three').text(Math.max(...second) + ' messages sent');
                        }

                    })

                    var ttttt3 = generateData(filteredData1.length, filteredData1, "wed", {
                        min: -30,
                        max: 55
                    });
                    const modifiedData3 = ttttt3.map(item => {
                        const xValue = item.x.replace(" AM", "").replace(" PM", "");
                        return {
                            ...item,
                            x: xValue
                        };
                    });


                    modifiedData3.forEach(element => {

                        if (element.x >= 10 && element.x <= 11) {
                            // console.log('dsfsd', element.x)
                            $('#four').text(Math.max(...second) + ' messages sent');
                        }
                    })
                }
            });
        }
// setTimeout(() => {
//     $('.apexcharts-toolbar .apexcharts-menu-icon').html('john')
// }, 4000);
        
    </script>

@endsection
