<!DOCTYPE html>
<html lang="en">

<head>
    <link rel="shortcut icon" href="{{ asset('images/favicon.png') }}">
    <title>Smarthub - RN</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta charset="utf-8">
    <link rel="stylesheet" type="text/css" href="{{ asset('css/content.css') }}" media="screen" />
    <link rel="stylesheet" type="text/css" href="{{ asset('css/login.css') }}" media="screen" />

    <script src="{{ asset('js/cdntailwindcss.js') }}"></script>

    <style>
        body {
            background-color: #f0f2f5 !important;
            font-family: -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, "Helvetica Neue", Helvetica, Arial,
                sans-serif !important;
        }
    </style>
</head>

<body class="h-full w-full">
    <div class="flex items-center justify-center h-screen">
        <div class="relative flex flex-col mt-6 text-gray-700 bg-white shadow-md bg-clip-border rounded-xl w-96">
            <div class="p-6 w-full">
              <h5 class="block mb-2 flex flex-col items-center justify-center font-sans text-xl antialiased font-semibold leading-snug tracking-normal text-blue-gray-900">
                <img class="login-form__logo" height="60" width="60" id="lo_logo" src="{{ asset('images/favicon.png') }}" alt="Logo" >
                <p class="pt-2 font-medium text-[20px] mt-4 -mb-2"  style="background: linear-gradient(90deg, #162dd5 -6%, #c65149 30%, #601ca5 85%, #3c6ff0 120%); -webkit-background-clip: text; -webkit-text-fill-color: transparent;">Pre-Beta Login</p>
              </h5>
              @if (session('success'))
                <p class="addsession">{{ session('success') }}</p>
              @endif
              <form class=" mt-6 w-80" action="{{ url('/login') }}" method="POST">
                @csrf
                <div class="flex flex-col gap-6 mb-1">
                  <h6
                    class="block -mb-3 font-sans tracking-[4px] text-base antialiased font-bold leading-relaxed tracking-normal text-[#1a4bae]">
                    Username
                  </h6>
                  <div class="w-80">
                    <div class="relative h-10 w-full min-w-[200px] ">
                    <input type="hidden"  name="type" value="Admin">
                      <input type="text" placeholder="Username *" name="Email" id="name" required
                        class="peer h-full w-full rounded-[7px]  !border  !border-gray-300 border-t-transparent bg-transparent bg-white px-3 py-2.5 font-sans text-sm font-normal text-blue-gray-700  shadow-lg shadow-gray-900/5 outline outline-0 ring-4 ring-transparent transition-all placeholder:text-gray-500 placeholder-shown:border placeholder-shown:border-blue-gray-200 placeholder-shown:border-t-blue-gray-200 focus:border-2  focus:!border-gray-900 focus:border-t-transparent focus:!border-t-gray-900 focus:outline-0 focus:ring-gray-900/10 disabled:border-0 disabled:bg-blue-gray-50" />
                    </div>
                  </div>
                  <h6
                    class="block -mt-3 font-sans tracking-[4px] text-base antialiased font-bold leading-relaxed tracking-normal text-[#1a4bae]">
                    Password
                  </h6>
                  <div class="w-80 -mt-3">
                    <div class="relative h-10 w-full min-w-[200px] ">
                      <input type="password" placeholder="Password *" name="Password" id="Password" required
                        class="peer h-full w-full rounded-[7px]  !border  !border-gray-300 border-t-transparent bg-transparent bg-white px-3 py-2.5 font-sans text-sm font-normal text-blue-gray-700  shadow-lg shadow-gray-900/5 outline outline-0 ring-4 ring-transparent transition-all placeholder:text-gray-500 placeholder-shown:border placeholder-shown:border-blue-gray-200 placeholder-shown:border-t-blue-gray-200 focus:border-2  focus:!border-gray-900 focus:border-t-transparent focus:!border-t-gray-900 focus:outline-0 focus:ring-gray-900/10 disabled:border-0 disabled:bg-blue-gray-50" />
                    </div>
                  </div>
                  <div class="p-6 pt-0 text-center">
                    <button name="Login"
                      class="align-middle select-none font-sans font-bold text-center uppercase transition-all disabled:opacity-50 disabled:shadow-none disabled:pointer-events-none text-xs py-3 px-6 rounded-lg bg-gray-900 text-white shadow-md shadow-gray-900/10 hover:shadow-lg hover:shadow-gray-900/20 focus:opacity-[0.85] focus:shadow-none active:opacity-[0.85] active:shadow-none"
                      type="submit">
                      Login
                      
                    </button>
                    <br>
                    <a class="login-form__link" href="{{ url('/staff_login') }}">Staff login</a>
                  </div>
              </form>
            </div>
        </div>
    </div>
</body>

</html>


{{-- 
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <link rel="shortcut icon" href="{{ asset('images/favicon.png') }}">
    <title>Smarthub - RN</title>
    <script src="{{ asset('js/cdntailwindcss.js') }}"></script>
    <style>
        .rnb_sign_in_banner {
            background-image: linear-gradient(60deg, #2531C0A1 0%, #F7BFBFA1 40%, rgba(251, 127, 119, 0.63) 63%, #1A08C4A1 100%), url(https://www.routenote.com/rn/_assets/sign-in/sign-in-lights-hero.png), url(https://www.routenote.com/rn/_assets/sign-in/sign-in-hero.jpg);
            background-size: cover;
            background-position: bottom;
            background-repeat: no-repeat;
        }
    </style>
</head>

<body class="h-screen grid place-items-center">
    <div class="flex w-full max-w-sm mx-auto overflow-hidden bg-white rounded-lg shadow-lg dark:bg-gray-800 lg:max-w-4xl h-[40rem]">

        <div class="w-full px-6 py-8 md:px-8 lg:w-1/2 grid place-items-center">
          <div class="w-full">
            <div class="flex justify-center mx-auto">
                <svg version="1.1" viewBox="0 0 60 60" class="svg-icon svg-fill" style="width: 60px; height: 60px;"><g fill="#1345AC" fill-rule="nonzero"><path pid="0" d="M35.88 1.02C34.5.72 33.12.6 31.68.36h-3.72c-1.56.24-3.12.42-4.68.72C11.64 3.6 2.22 13.56.42 25.26.24 26.28.12 27.3 0 28.32v3.72c.24 1.5.42 3 .72 4.44 2.58 12 12.18 21.06 24.3 23.1 14.58 2.4 28.8-6.3 33.18-20.34 5.34-16.92-4.98-34.56-22.32-38.22zM29.82 56.1C15.48 56.1 3.9 44.52 3.9 30.18 3.9 15.84 15.54 4.2 29.88 4.26c14.28 0 25.86 11.64 25.86 25.92 0 14.28-11.58 25.92-25.92 25.92z"></path><path pid="1" d="M37.38 41.58c-2.7.36-6.3-2.1-7.38-4.98.18-.06.36-.12.48-.18 5.76-2.22 9.06-7.98 7.98-13.98-1.08-5.94-6.24-10.2-12.36-10.2H13.8v4.08h.9c3.9 0 7.8-.06 11.64 0 4.44.06 7.98 3.6 8.16 7.98.18 4.38-3.06 8.16-7.5 8.64-.6.06-1.2.06-1.74.12-.36 1.74.36 4.68 1.74 6.78 2.4 3.78 5.88 5.7 10.44 6v2.1c2.58-1.44 5.1-2.76 7.68-4.2-2.64-1.44-5.1-2.82-7.74-4.2v2.04z"></path></g></svg>
            </div>

            <p class="mt-3 text-xl text-center text-gray-600 dark:text-gray-200">
                Pre-Beta Login
            </p>

            <div class="mt-4">
                <label class="block mb-2 text-sm font-medium text-gray-600 dark:text-gray-200"
                    for="LoggingEmailAddress">Email Address</label>
                <input id="LoggingEmailAddress"
                    class="block w-full px-4 py-2 text-gray-700 bg-white border rounded-lg dark:bg-gray-800 dark:text-gray-300 dark:border-gray-600 focus:border-blue-400 focus:ring-opacity-40 dark:focus:border-blue-300 focus:outline-none focus:ring focus:ring-blue-300"
                    type="email">
            </div>

            <div class="mt-4">
                <div class="flex justify-between">
                    <label class="block mb-2 text-sm font-medium text-gray-600 dark:text-gray-200"
                        for="loggingPassword">Password</label>
                </div>

                <input id="loggingPassword"
                    class="block w-full px-4 py-2 text-gray-700 bg-white border rounded-lg dark:bg-gray-800 dark:text-gray-300 dark:border-gray-600 focus:border-blue-400 focus:ring-opacity-40 dark:focus:border-blue-300 focus:outline-none focus:ring focus:ring-blue-300"
                    type="password">
            </div>

            <div class="mt-6">
                <button
                    class="w-full px-6 py-3 text-sm font-medium tracking-wide text-white capitalize transition-colors duration-300 transform bg-gray-800 rounded-lg hover:bg-gray-700 focus:outline-none focus:ring focus:ring-gray-300 focus:ring-opacity-50">
                    Sign In
                </button>
            </div>
            <div class="flex items-center justify-between mt-4">
                <span class="w-1/5 border-b border-white md:w-1/4"></span>

                <a href="#" class="text-xs text-gray-500 uppercase dark:text-gray-400 hover:underline"></a>

                <span class="w-1/5 border-b border-white md:w-1/4"></span>
            </div>
          </div>
        </div>
        <div class="rnb_sign_in_banner hidden bg-cover lg:block lg:w-1/2"></div>
    </div>
</body>

</html> --}}
