@extends('includes.layout')
@section('content')
<!DOCTYPE html>
<html lang="en">

<head>
    <script src="https://unpkg.com/@material-tailwind/html@latest/scripts/dismissible.js"></script>
    <link rel="stylesheet" href="//code.jquery.com/ui/1.12.1/themes/smoothness/jquery-ui.css">
    <script src="//code.jquery.com/jquery-1.12.4.js"></script>
    <script src="//code.jquery.com/ui/1.12.1/jquery-ui.js"></script>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css" rel="stylesheet">

    <!-- jQuery -->
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>


    <style>
    

    #ddddd tr:hover {
        background: #bbbbbb66 !important;
    }
    </style>
    <!-- Bootstrap JS -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js"></script>
    <script>
    $(document).ready(function() {
        // When the 'Add New Record' button is clicked, show the modal with empty fields for insertion
        $('#addButton').click(function() {
            // Clear any pre-existing values in the modal fields
            $('#modal_name').val('');
            $('#modal_to').val('');
            $('#modal_subject').val('');
            $('#modal_cc').val('');
            $('#modal_status').prop('checked', false); // Set default status to false (unchecked)
            $('#distid').val(''); // Clear distid field

            // Set the 'Save Changes' button to handle insert, not update
            $('#confirmUpdateButton').data('id', null); // No ID means insert

            // Show the modal
            $('#updateModal').modal('show');
        });

        // When the 'Modify' button is clicked, populate the modal with the existing data
        $('.update-button').click(function() {
            var id = $(this).data('id');
            var store_name = $(this).data('store_name');
            var toMail = $(this).data('to');
            var subject = $(this).data('subject');
            var cc = $(this).data('cc');
            var distid = $(this).data('distid');
            var status = $(this).data('status');

            // Fill in the modal with the current record's data
            $('#modal_name').val(store_name);
            $('#modal_to').val(toMail);
            $('#modal_subject').val(subject);
            $('#modal_cc').val(cc);
            $('#distid').val(distid); // Correct assignment of distid
            $('#modal_status').prop('checked', status === 'on'); // Check the box if status is 'on'

            // Set the 'Save Changes' button to handle update, not insert
            $('#confirmUpdateButton').data('id', id);

            // Show the modal
            $('#updateModal').modal('show');
        });

        // Handle the Save Changes button click (both update and insert)
        $('#confirmUpdateButton').click(function() {
            var recordId = $(this).data('id'); // Get the record ID (null for insert)

            var toMail = $('#modal_to').val();
            var subject = $('#modal_subject').val();
            var cc = $('#modal_cc').val();
            var distid = $('#distid').val(); // Corrected to fetch distid from the correct field
            var status = $('#modal_status').prop('checked') ? 'on' : 'off';

            // Validation: Make sure all fields are filled in
            if (!toMail.trim() || !subject.trim()) {
                alert('All fields are required!');
                return;
            }

            // Choose the URL based on whether we're inserting or updating
            var url = recordId ? '{{ route('toggle.update') }}': '{{ route('toggle.insert') }}';

            $.ajax({
                url: url,
                method: 'POST',
                data: {
                    _token: '{{ csrf_token() }}',
                    id: recordId, // Only passed if updating
                    to_mail: toMail,
                    subject: subject,
                    cc: cc,
                    distid: distid,
                    toggle: status,
                },
                success: function(response) {
                    if (response.success) {
                        alert(response.message);
                        $('#updateModal').modal('hide');
                        location
                            .reload(); // Reload the page to show the updated or newly inserted data
                    } else {
                        alert('Operation failed: ' + response.message);
                    }
                },
                error: function(xhr) {
                    alert('Error: ' + xhr.responseText);
                }
            });
        });
    });
    </script>

</head>

<body>
    <div class="p-4">
        <div class="flex gap-3 items-center justify-between">
            <div class="flex gap-3 items-center">
                <h1 class="text-2xl font-sans font-bold flex items-center gap-2">
                    <span>Manage Store List</span>
                    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor"
                        class="bi bi-people-fill" viewBox="0 0 16 16">
                        <path
                            d="M7 14s-1 0-1-1 1-4 5-4 5 3 5 4-1 1-1 1zm4-6a3 3 0 1 0 0-6 3 3 0 0 0 0 6m-5.784 6A2.24 2.24 0 0 1 5 13c0-1.355.68-2.75 1.936-3.72A6.3 6.3 0 0 0 5 9c-4 0-5 3-5 4s1 1 1 1zM4.5 8a2.5 2.5 0 1 0 0-5 2.5 2.5 0 0 0 0 5" />
                    </svg>
                </h1>

            </div>

            <!--div class="mb-3">
                    <button id="addButton"
                        class="align-middle select-none font-sans font-bold text-center uppercase transition-all disabled:opacity-50 disabled:shadow-none disabled:pointer-events-none text-xs py-3 px-6 rounded-lg bg-gray-900 text-white shadow-md shadow-gray-900/10 hover:shadow-lg hover:shadow-gray-900/20 focus:opacity-[0.85] focus:shadow-none active:opacity-[0.85] active:shadow-none flex items-center gap-3"
                        type="button">
                        <svg width="18" height="20" viewBox="0 0 18 20" fill="none"
                            xmlns="http://www.w3.org/2000/svg">
                            <path
                                d="M14.593 1.322C15.693 1.45 16.5 2.399 16.5 3.507V19L9 15.25L1.5 19V3.507C1.5 2.399 2.306 1.45 3.407 1.322C7.12319 0.890632 10.8768 0.890632 14.593 1.322Z"
                                stroke="white" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" />
                            <path
                                d="M9.42425 4.07574C9.31173 3.96321 9.15912 3.9 8.99999 3.9C8.84086 3.9 8.68825 3.96321 8.57573 4.07574C8.4632 4.18826 8.39999 4.34087 8.39999 4.5V7.4H5.49999C5.34086 7.4 5.18825 7.46321 5.07573 7.57574C4.9632 7.68826 4.89999 7.84087 4.89999 8C4.89999 8.15913 4.9632 8.31174 5.07573 8.42426C5.18825 8.53679 5.34086 8.6 5.49999 8.6H8.39999V11.5C8.39999 11.6591 8.4632 11.8117 8.57573 11.9243C8.68825 12.0368 8.84086 12.1 8.99999 12.1C9.15912 12.1 9.31173 12.0368 9.42425 11.9243C9.53678 11.8117 9.59999 11.6591 9.59999 11.5V8.6H12.5C12.6591 8.6 12.8117 8.53679 12.9243 8.42426C13.0368 8.31174 13.1 8.15913 13.1 8C13.1 7.84087 13.0368 7.68826 12.9243 7.57574C12.8117 7.46321 12.6591 7.4 12.5 7.4H9.59999V4.5C9.59999 4.34087 9.53678 4.18826 9.42425 4.07574Z"
                                fill="white" stroke="white" stroke-width="0.2" />
                        </svg>
                        Add Store
                    </button>
                </div-->

        </div>
        <br>
        <!-- ------------------------ All Users ---------------------------------- -->
        <div id="view1" class="">
            <div class="flex w-full justify-between">
                <h5
                    class="block mb-2 font-sans text-xl antialiased font-bold leading-snug tracking-normal text-blue-gray-900">
                    All Stores
                </h5>
                <div class="relative h-10 min-w-[200px]">
                    <input type="text" placeholder="Search" id="type_search" class="rounded-[10px] border py-2 px-4" />
                </div>
            </div>
            <br>
            <div class="relative overflow-x-auto shadow-md sm:rounded-lg h-[30rem]">
                <table id="myTable" class="w-full text-sm text-left rtl:text-right text-gray-500 darks:text-gray-400">
                    <thead
                        class="text-xs text-gray-700 uppercase bg-gray-50 darks:bg-gray-700 darks:text-gray-400 sticky top-0">
                        <tr style="color: #fff;text-align: center;">
                            <th scope="col" class="border-r sticky top-0 bg-[#000] px-6 py-3">
                                Name
                            </th>
                            <th scope="col" class="border-r sticky top-0 bg-[#000] px-6 py-3">
                                To
                            </th>
                            <th scope="col" class="border-r sticky top-0 bg-[#000] px-6 py-3">
                                Subject
                            </th>
                            <th scope="col" class="border-r sticky top-0 bg-[#000] px-6 py-3">
                                cc
                            </th>
                            <th scope="col" class="border-r sticky top-0 bg-[#000] px-6 py-3  w-[100px]">
                                On/off
                            </th>

                            <th scope="col" class="border-r sticky top-0 bg-[#000] px-6 py-3  w-[100px] ">
                                MODIFY
                            </th>
                        </tr>
                    </thead>

                    <tbody class="overflow-y-auto" id="ddddd">
                        @foreach ($storeNames as $storeName)
                        <tr>
                            <td>{{ $storeName->store_name }}</td>
                            @php
                            $found = false; // Initialize flag to check if a match is found
                            @endphp
                            @foreach ($toggle as $toggles)
                            @if ($storeName->dist_id == $toggles->dist_id)
                            @php
                            $found = true;
                            @endphp
                            <td class="truncate max-w-[100px]">{{ $toggles->to_mail }}</td>
                            <td class="truncate max-w-[150px]">{{ $toggles->subject }}</td>
                            <td class="truncate max-w-[150px]">{{ $toggles->cc }}</td>
                            <td class="grid place-items-center w-[100px]">
                                <!-- Toggle button for status -->
                                <div class="form-check form-switch !block">
                                    <input class="form-check-input toggle-status" type="checkbox"
                                        data-id="{{ $toggles->id }}" {{ $toggles->toggle == '1' ? 'checked' : '' }}>
                                    <label class="form-check-label"></label>
                                </div>
                            </td>
                            <td class="text-center">
                                <button type="button" class="btn-warning update-button" data-id="{{ $toggles->id }}"
                                    data-distid="{{ $storeName->dist_id }}" data-name="{{ $toggles->name ?? '' }}"
                                    data-to="{{ $toggles->to_mail }}" data-subject="{{ $toggles->subject }}"
                                    data-cc="{{ $toggles->cc }}" data-status="{{ $toggles->toggle }}">
                                    Modify
                                </button>
                            </td>
                            @endif
                            @endforeach

                            <!-- Render empty cells if no match is found -->
                            @if (!$found)
                            <td></td>
                            <td></td>
                            <td></td>
                            <td class="grid place-items-center">
                                <div class="form-check form-switch !block">
                                    <input class="form-check-input toggle-status" type="checkbox" disabled>
                                    <label class="form-check-label"></label>
                                </div>
                            </td>
                            <td>
                                <button type="button" class="btn-warning update-button" data-id=""
                                    data-distid="{{ $storeName->dist_id }}" data-name="" data-to="" data-subject=""
                                    data-status="">
                                    Modify
                                </button>
                            </td>
                            <td></td>
                            @endif
                        </tr>
                        @endforeach
                    </tbody>





                    </tbody>
                </table>
            </div>
            <div class="w-full text-end">
                <div id="pagination" class="mt-3"></div>
            </div>
        </div>

    </div>
    <!-- Modal Structure -->
    <div class="modal fade" id="updateModal" tabindex="-1" aria-labelledby="updateModalLabel" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="updateModalLabel">Add or Update Store Details</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <!-- Name field added here -->
                    <!--div class="mb-3">
                            <label for="modal_name" class="form-label">Name</label>
                            <input type="text" id="modal_name" class="form-control" placeholder="Enter name" />
                        </div-->
                    <div class="mb-3">
                        <label for="modal_to" class="form-label">To Email</label>
                        <input type="email" id="modal_to" class="form-control" placeholder="Enter To email" />
                    </div>
                    <div class="mb-3">
                        <label for="modal_subject" class="form-label">Subject</label>
                        <input type="text" id="modal_subject" class="form-control" placeholder="Enter subject" />
                    </div>
                    <div class="mb-3">
                        <label for="modal_cc" class="form-label">Cc</label>
                        <input type="text" id="modal_cc" class="form-control" placeholder="Enter cc" />
                        <input type="hidden" id="distid" class="form-control" placeholder="Enter cc" />
                    </div>
                    <div class="mb-3">
                        <label for="modal_status" class="form-label">Modify <div class="w-full text-end">
                                <div id="pagination" class="mt-3"></div>
                            </div></label>
                        <div class="form-check form-switch !block">
                            <input type="checkbox" id="modal_status" class="form-check-input" />
                            <label class="form-check-label" for="modal_status"></label>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                    <button type="button" id="confirmUpdateButton" class="btn btn-success">Save Changes</button>
                </div>
            </div>
        </div>
    </div>
    <script>
    function modifyToggle(element) {
        var id = element.getAttribute('data-id');
        var name = element.getAttribute('data-name');
        var toMail = element.getAttribute('data-to');
        var subject = element.getAttribute('data-subject');
        var status = element.getAttribute('data-status');

        // Here, you can perform whatever action you want with the data
        // For example, open a modal or make an AJAX request with these values

        console.log(id, name, toMail, subject, status); // Replace with your desired functionality
    }
    </script>
    <script>
    function myFunction3() {
        var input, filter, table, tr, td, i, txtValue;
        input = document.getElementById("myInput2");
        filter = input.value.toUpperCase();
        table = document.getElementById("myTable2");
        tr = table.getElementsByTagName("tr");
        for (i = 0; i < tr.length; i++) {
            td = tr[i].getElementsByTagName("td")[0];
            console.log('td', td)
            if (td) {
                txtValue = td.textContent || td.innerText;

                if (txtValue.toUpperCase().indexOf(filter) > -1) {
                    tr[i].style.display = "";
                } else {
                    tr[i].style.display = "none";
                }
            }
        }
    }

    // ************************** HP Account ( High Profile )


    function myFunction4() {
        var input, filter, table, tr, td, i, txtValue;
        input = document.getElementById("myInput3");
        filter = input.value.toUpperCase();
        table = document.getElementById("myTable3");
        tr = table.getElementsByTagName("tr");
        for (i = 0; i < tr.length; i++) {
            td = tr[i].getElementsByTagName("td")[0];
            console.log('td', td)
            if (td) {
                txtValue = td.textContent || td.innerText;

                if (txtValue.toUpperCase().indexOf(filter) > -1) {
                    tr[i].style.display = "";
                } else {
                    tr[i].style.display = "none";
                }
            }
        }
    }



    document.getElementById('type_search').addEventListener('keyup', function() {
        let filter = this.value.toUpperCase();
        let table = document.getElementById('myTable');
        let rows = table.getElementsByTagName('tr');
        let noResults = true; // Flag to track if any results were found

        // Clear any previous "No Results" message if exists
        let noResultsRow = document.getElementById('noResultsRow');
        if (noResultsRow) {
            noResultsRow.remove(); // Remove the "No Results" row if it exists
        }

        for (let i = 1; i < rows.length; i++) {
            let cells = rows[i].getElementsByTagName('td');
            let rowMatch = false;
            for (let j = 0; j < cells.length; j++) {
                if (cells[j].textContent.toUpperCase().indexOf(filter) > -1) {
                    rowMatch = true;
                    break;
                }
            }
            if (rowMatch) {
                rows[i].style.display = ""; // Show the row if it matches
                noResults = false; // At least one result was found
            } else {
                rows[i].style.display = "none"; // Hide the row if it doesn't match
            }
        }

        // If no results are found, show the "No Results Found" row
        if (noResults && filter !== "") {
            let newRow = table.insertRow();
            newRow.id = 'noResultsRow'; // Assign an ID to the "No Results" row
            let cell = newRow.insertCell();
            cell.colSpan = rows[0].cells.length; // Span across all columns
            cell.textContent = 'No Results Found!';
            newRow.style.textAlign = 'center';
            newRow.style.backgroundColor = '#fff'; // Optional: background color for visibility
            newRow.style.fontWeight = 'bold'; // Optional: make the text bold
        }
    });
    </script>

</body>

</html>
@endsection