<!DOCTYPE html>
<html lang="en">

<head>
    <link rel="shortcut icon" href="{{ asset('images/favicon.png') }}">
    <title>Smarthub - RN</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta charset="utf-8">
    <link rel="stylesheet" type="text/css" href="{{ asset('css/content.css') }}" media="screen" />
    <link rel="stylesheet" type="text/css" href="{{ asset('css/login.css') }}" media="screen" />

    <script src="{{ asset('js/cdntailwindcss.js') }}"></script>

    <style>
        body {
            background-color: #f0f2f5 !important;
            font-family: -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, "Helvetica Neue", Helvetica, Arial,
                sans-serif !important;
        }
    </style>
</head>

<body class="h-full w-full">
    <div class="flex items-center justify-center h-screen">
        <div class="relative flex flex-col mt-6 text-gray-700 bg-white shadow-md bg-clip-border rounded-xl w-96">
            <div class="p-6 w-full">
              <h5 class="block mb-2 flex flex-col items-center justify-center font-sans text-xl antialiased font-semibold leading-snug tracking-normal text-blue-gray-900">
                <img class="login-form__logo" height="60" width="60" id="lo_logo" src="{{ asset('images/favicon.png') }}" alt="Logo" >
                <p class="pt-2 font-medium text-[20px] mt-4 -mb-2"  style="background: linear-gradient(90deg, #162dd5 -6%, #c65149 30%, #601ca5 85%, #3c6ff0 120%); -webkit-background-clip: text; -webkit-text-fill-color: transparent;">Pre-Beta Login</p>
              </h5>
              @if(session('success')) 
                <p class="addsession">{{ session('success') }}</p>
              @endif
              <form class=" mt-6 w-80" action="{{ url('/login') }}" method="POST">
                @csrf
                <div class="flex flex-col gap-6 mb-1">
                  <h6
                    class="block -mb-3 font-sans tracking-[4px] text-base antialiased font-bold leading-relaxed tracking-normal text-[#1a4bae]">
                    Username
                  </h6>
                  <div class="w-80">
                    <div class="relative h-10 w-full min-w-[200px] ">
                    <input type="hidden"  name="type" value="Staff">
                      <input type="text" placeholder="Username *" name="Email" id="name" required
                        class="peer h-full w-full rounded-[7px]  !border  !border-gray-300 border-t-transparent bg-transparent bg-white px-3 py-2.5 font-sans text-sm font-normal text-blue-gray-700  shadow-lg shadow-gray-900/5 outline outline-0 ring-4 ring-transparent transition-all placeholder:text-gray-500 placeholder-shown:border placeholder-shown:border-blue-gray-200 placeholder-shown:border-t-blue-gray-200 focus:border-2  focus:!border-gray-900 focus:border-t-transparent focus:!border-t-gray-900 focus:outline-0 focus:ring-gray-900/10 disabled:border-0 disabled:bg-blue-gray-50" />
                    </div>
                  </div>
                  <h6
                    class="block -mt-3 font-sans tracking-[4px] text-base antialiased font-bold leading-relaxed tracking-normal text-[#1a4bae]">
                    Password
                  </h6>
                  <div class="w-80 -mt-3">
                    <div class="relative h-10 w-full min-w-[200px] ">
                      <input type="password" placeholder="Password *" name="Password" id="Password" required
                        class="peer h-full w-full rounded-[7px]  !border  !border-gray-300 border-t-transparent bg-transparent bg-white px-3 py-2.5 font-sans text-sm font-normal text-blue-gray-700  shadow-lg shadow-gray-900/5 outline outline-0 ring-4 ring-transparent transition-all placeholder:text-gray-500 placeholder-shown:border placeholder-shown:border-blue-gray-200 placeholder-shown:border-t-blue-gray-200 focus:border-2  focus:!border-gray-900 focus:border-t-transparent focus:!border-t-gray-900 focus:outline-0 focus:ring-gray-900/10 disabled:border-0 disabled:bg-blue-gray-50" />
                    </div>
                  </div>
                  <div class="p-6 pt-0 text-center">
                    <button name="Login"
                      class="align-middle select-none font-sans font-bold text-center uppercase transition-all disabled:opacity-50 disabled:shadow-none disabled:pointer-events-none text-xs py-3 px-6 rounded-lg bg-gray-900 text-white shadow-md shadow-gray-900/10 hover:shadow-lg hover:shadow-gray-900/20 focus:opacity-[0.85] focus:shadow-none active:opacity-[0.85] active:shadow-none"
                      type="submit">
                      Login
                      
                    </button>
                    <br>
                    <a class="login-form__link" href="{{ url('/login') }}">Super Admin Login</a>
                  </div>
              </form>
            </div>
        </div>
    </div>
    {{-- <div class="rn-login">
        <div class="log-flex">
            <img class="login-form__logo" id="li_logo" src="{{ asset('images/rn-logo.svg') }}" alt="Logo" style="display:none">
            <img class="login-form__logo" id="lo_logo" src="{{ asset('images/rn-logo.svg') }}" alt="Logo"
                style="display:none">
            <script>
                var li_logo1 = document.getElementById('li_logo');
                var lo_logo1 = document.getElementById('lo_logo');
                if (window.location.host == 'localhost') {
                    li_logo1.style.display = 'none';
                    lo_logo1.style.display = 'block';
                } else {
                    li_logo1.style.display = 'block';
                    lo_logo1.style.display = 'none';
                }
            </script>
            <div>Smart Hub</div>
        </div>
        <form class="login-form" action="{{ url('/login') }}" method="POST">
		  @if(session('success'))
    <p class="addsession">{{ session('success') }}</p>
@endif
            @csrf
            <div class="login-form__content">
                <div class="login-form__header">Login as Super Admin</div>
                <div style="color:red;text-align: center;"> {{ $pass ?? '' }} </div>
                <label for="name">Username</label>
                <input class="login-form__input" type="text" name="Email" id="name" placeholder="Username">
                <label for="Password">Password</label>
                <input class="login-form__input" type="password" name="Password" id="Password" placeholder="Password">
                <button class="btn btn-primary btn-block" type="submit" name="Login">Login</button>
                <div class="login-form__links">
                    <a class="login-form__link" href="{{ url('/staff_login') }}">Staff login</a>
                    
                </div>
            </div>
        </form>
    </div> --}}
</body>

</html>
