<html>
   <head>
        <link rel="shortcut icon" href="../images/favicon.png">
        <meta name="csrf-token" content="{{ csrf_token() }}">
        <title>Smarthub - RN</title>
        @vite('resources/css/app.css')
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.1/jquery.min.js"></script>
        <style>
        html,body{
            font-family: -apple-system,BlinkMacSystemFont,"Segoe UI",Roboto,"Helvetica Neue",Helvetica,Arial,sans-serif !important;
        }
        button {
            height: 2.5rem;
            width: 50%;
            border-radius: 5px;
            border: 2px solid #1345ac;
            background: transparent;
            letter-spacing: 1px;
            cursor: pointer;
            background: #1345ac;
            color: #fff;
            font-weight: bold;
        }
        button:hover {
            border: 2px solid #1345ac;
            color: #1345ac;
            background-color: #fff;
        }
        input[type=text], select , input[type=email]{
            width: 100%;
            padding: 12px 20px;
            margin: 8px 0;
            display: inline-block;
            border: 1px solid #ccc;
            border-radius: 4px;
            box-sizing: border-box;
        }

        input[type=submit] {
            width: 50%;
            background-color: #1345AC;
            color: white;
            padding: 14px 20px;
            margin: 8px 0;
            border: none;
            border-radius: 4px;
            cursor: pointer;
            font-weight: bolder;
            letter-spacing: 1px;
            border: 2px solid #1345AC;
            text-align: center;
        }
        input[type=cancel] {
            width: 43%;
            background-color: #1345AC;
            color: white;
            padding: 14px 20px;
            margin: 8px 0;
            border: none;
            border-radius: 4px;
            cursor: pointer;
            font-weight: bolder;
            letter-spacing: 1px;
            border: 2px solid #1345AC;
            text-align: center;
        }

        input[type=submit]:hover {
            border: 2px solid #1345AC;
            background-color: #fff;
            color: #1345AC;
        }
        input[type=cancel]:hover {
            border: 2px solid #1345AC;
            background-color: #fff;
            color: #1345AC;
        }

        #tabless div:nth-child(1),
        #tabless div:nth-child(2),
        #tabless div:nth-child(3),
        #tabless div:nth-child(4),
        #tabless div:nth-child(5) {
            /* height: 1.7rem; */
            background: #ddd0;
            display: flex;
            justify-content: space-around;
            width: 100%;
            gap: 9px;
            margin-bottom: 8px;
            padding: 8px;
            border-radius: 7px;
        }
        #tabless div label {
            width: 50%;
        }
        #tabless div label:nth-child(1) {
            display: flex;
            justify-content: space-between;
        }
        table tr {
            line-height: 40px;
        }
        table tr td:nth-child(2) {
            padding-left: 1rem;
        }
    </style>
   </head>
        <body>
            

            <div style="height: 9rem;display: flex;justify-content: center;align-items: end;">
                <img src="/images/rn-logo.svg" alt="Logo" title="RouteNote">
                <!-- <img src="/images/unnamed.png" alt="Logo" title="RouteNote"> -->
            </div>
            <div style="display: flex;flex-direction: column;align-items: center;margin-top: 1rem;gap: 2rem;padding: 0 25rem;" id="btn-div">
                <div id="tabless">

                <table>
                    <tr>
                        <td>UserName :</td>
                        <td>{{$name ?? ''}}</td>
                    </tr>
                    <tr>
                        <td>RN EmailId :</td>
                        <td>{{$mailid ?? ''}}</td>
                    </tr>
                    <tr>
                        <td>UID :</td>
                        <td>{{$id ?? ''}}</td>
                    </tr>
                    <tr>
                        <td>Requested Email Address :</td>
                        <td>{{$Req_email ?? ''}}</td>
                    </tr>
                    @if($list == 'otl')
                        <tr>
                            <td>Action List :</td>
                            <td>{{$action ?? ''}}</td>
                        </tr>
                    @endif
                </table>
                
            <div style="width: 100%;display: flex;gap: 10px;padding: 8px;">
                <button Onclick="Approve()">Confirm</button>
                <button Onclick="Cancel()">Cancel</button>
            </div>
        </div>
        </div>
    </div>
    <script>
        <?php if($status != 0 && $ac_status != 0 ) {?>
            $('#btn-div').html('<div style="display:flex;gap:.5rem;justify-content: center;"><svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="#5383ec" class="bi bi-exclamation-circle-fill" viewBox="0 0 16 16" style="height: 24px;width: 22px;"><path d="M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0M8 4a.905.905 0 0 0-.9.995l.35 3.507a.552.552 0 0 0 1.1 0l.35-3.507A.905.905 0 0 0 8 4m.002 6a1 1 0 1 0 0 2 1 1 0 0 0 0-2"/></svg><div style="color: #5383ec;font-weight: bold;">Allready used...!</div></div>');
        <?php } ?>

        function Approve() {
            $.ajax({
                type: "post",
                url: "{{ route('userconfirm') }}",
                headers: {
                    'X-CSRF-TOKEN': '{{ csrf_token() }}'
                },
                data: {
                    "ref": "Confirmation_approve",
                    "ids": '<?php echo $id; ?>',
                    "list_id": <?php if($list == 'otl'){echo "1";}else{echo "0";}?>
                },
                success: function(result) {
                    $('#btn-div').html('<div style="display:flex;gap:.5rem;justify-content: center;"><img src="/images/approve_tik.svg" style="height:24px;width:24px;" /><div style="color: green;font-weight: bold;">'+result.message+'</div></div>');
                }
            })
        }

        function Cancel() {
            var settings1 = {
                type: "post",
                url: "{{ route('userconfirm') }}",
                headers: {
                    'X-CSRF-TOKEN': '{{ csrf_token() }}'
                },
                "data": {
                    "ref": "Confirmation_cancel",
                    "ids": '<?php echo $id; ?>',
                    "list_id": "0"
                }
            };

            $.ajax(settings1).done(function (response) {
                $('#btn-div').html('<div style="display:flex;gap:.5rem;justify-content: center;"><img src="<?php echo $site_url; ?>/images/approve_tik.svg" style="height:24px;width:24px;" /><div style="color: green;font-weight: bold;">'+response+'</div></div>');
            });
        }
    </script>
</body>
</html>









