<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <meta name="csrf-token" content="<?php echo e(csrf_token()); ?>">
    <link rel="icon" type="image/png" href="<?php echo e(asset('images/favicon.png')); ?>" id="favicon">
    <title>Smarthub - RN</title>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <style>
        p {
            margin: 0;
        }
        #demo-age {
            display: flex;
            flex-direction: column;
            gap: 2px;
        }
    </style>
</head>
<body>
    <div id="demo-age"></div>
    <script>
        function TBallmail(e) {
            $.ajax({
                type: "GET",
                url: "<?php echo e(route('showage')); ?>",
                success: function(result) {
                    var data = result;

                    if(data.length > 0) {
                        if(data.length > 0) {
                            data.forEach((item, index) => {
                                
                                const formatted = new Date(item.tickets_received).toLocaleDateString('en-GB', {
                                    day: '2-digit',
                                    month: 'short',
                                    year: '2-digit',
                                }).replace(/ /g, '-');
                                const firstTwoChars = item.name.slice(0, 2);

                                var currentDateTime = new Date();
                                var givenDateTime = new Date(item.tickets_received);
                                var differenceInMillis = currentDateTime - givenDateTime;
                                var differenceInHours = differenceInMillis / (1000 * 60 * 60);

                                const currentdate = new Date();
                                const createdate = new Date(item.tickets_received);
                                const scheduleHours = item.elapetime;
                                const scheduleMilliseconds = scheduleHours * 60 * 60 * 1000;
                                const timeDifference = currentdate - createdate; 
                                let status = "";

                                if (timeDifference >= scheduleMilliseconds) {
                                    status = "Expired";
                                } else {
                                    const remainingTime = scheduleMilliseconds - timeDifference;
                                    const remainingHours = Math.floor(remainingTime / (60 * 60 * 1000));
                                    const remainingMinutes = Math.floor((remainingTime % (60 * 60 * 1000)) / (60 * 1000));
                                    status = "Not";
                                }
                                if (status == "Expired") {
                                    $.ajax({
                                        type: "post",
                                        url: "<?php echo e(route('overdue')); ?>",
                                        headers: {
                                            'X-CSRF-TOKEN': '<?php echo e(csrf_token()); ?>'
                                        },
                                        data: {
                                            ids: item.id,
                                            hours: Number(differenceInHours),
                                            hour: item.elapetime
                                        },
                                        success: function(result) {
                                            // console.log('result', result);
                                            $('#demo-age').append(`<p>${result == "expired" ? "Ticket --- expired" : "Ticket --- sent"}</p>`);
                                        }
                                    })
                                }else {
                                    $('#demo-age').append(`<p>Not expired</p>`);
                                }
                            });
                        }
                    }                    
                }
            })
        };
        TBallmail();
    </script>
</body>
</html><?php /**PATH /var/www/html/smart-hub/resources/views//agging_cron.blade.php ENDPATH**/ ?>